/* Holden Ridge
 * hridge
 *
 */



#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>

#include <stdio.h>
#include <fstream>
#include <iostream>
#include <sstream>
//#include <Winbase.h>

#include "imageloader.h"
#define XWIN .8
// Comment out one
//#define XSLEEP usleep(20); //unix only
#define XSLEEP //sleep(20); //other
using namespace std;

//TEMP
float highesthight = 0.0;
float lowesthight = 0.0;

float _angle = 60.0f;
GLuint _texID; //id of texture
GLuint _skyID; //id of skybox
GLuint _skybox[5]; //holds faces of skybox

float landn[100][100][3];
float landp[100][100][2][3];

float pc1 = 0.0, pc2 = 0.0;
float ps[2][3];

int partAxis = 0;

//used to set shininess, not sure it actually does anything
GLfloat oneS[1] = {128};
GLfloat halfS[1] = {1};
GLfloat zeroS[1] = {0};
//used for glmaterialfv acalls
float whe3[3] = {0.01, 0.01, 0.01};
float zero3[3] = {0.0, 0.0, 0.0};
float dark3[3] = {0.1, 0.1, 0.1};
float half3[3] = {0.5, 0.5, 0.5};
float dgrey3[3] = {0.3, 0.3, 0.3};
float silver3[3] = {0.8, 0.8, 0.8};
float grey3[3] = {0.7, 0.7, 0.7};
float lgrey3[3] = {0.5, 0.5, 0.5};
float one3[3] = {1.0, 1.0, 1.0};
float red3[3] = {1.0, 0.01, 0.01};
float lred3[3] = {8.0, 0.2, 0.2};
float dred3[3] = {0.3, 0.0, 0.0};
float tan3[3] = {0.6, 0.5, 0.4};
float green3[3] = {0.0, 0.6, 0.0};
float blue3[3] = {0.0, 0.0, 1.0};
float yellow3[3] = {0.9, 0.9, 0.0};
float rg3[3] = {0.6, 0.6, 0.3};
float rb3[3] = {0.6, 0.3, 0.6};
float gb3[3] = {0.3, 0.6, 0.6};

float speed = 0.0;
float turn = 0.0;

float wheelSpin = 0.0;

int drawChassis = 1;

int drawGround = 0;
int drawNormal = 0;

int choice3 = 1;
int choice2 = 0;
int choice1 = 1;
int choice = 1;

int driverview = 0;
int noglass = 1;

float cameraUp = 10.0;
float cameraDegree = 0.0;
float cameraDistance = -35.0;

//diffuse yellow light
GLfloat light_diffuse[] = {1.0, 1.0, 1.0};
GLfloat light_hlight[] = {0.7, 0.7, 0.0};
//dim specular light
GLfloat light_specular[] = {0.3, 0.3, 0.3};
//really dim abmient light
GLfloat light_ambient[] = {0.4, 0.4, 0.4};
//light is located in the positive y direction
GLfloat light_position[] = {0.0, 1.0, 0.0, 0.0}; 

// the number of coordinates 
int coorLength;
int coormLength;

//keeps track of if gourard shading is on
int gshade = 0;

// draw normal vectors for each vertex?
int normals = 0;

// allows you to scale the ship manually
float scaler = 0.5;

// chooses object coordinates or world coordinates
// 0 is world coordinates


// allows you to rotate the ship manually
float rotateX = 0.0, rotateY = 0.0, rotateZ = 0.0;
float rotateC = 0.0;

// toggles displaying the world axis
int worldAxis = 1;

//holds the window size
int hight = 500, width = 500;

// the right left or middle button is held down
int rightC = 0, leftC = 0, middleC = 0;

// flag for if 'x' 'y', or 'z' were held down when
// a mouse button was clicked
int clickM = 0, clickH = 0, clickV = 0;

// position of the mouse updated as it moves if a mouse button
// is held down
float xMouse, yMouse;

// flag for if 'x', 'y', or 'z' is held down
int pressW = 0, pressA = 0, pressS = 0, pressD = 0, pressX = 0,
pressM = 0, pressV = 0, pressH = 0;

// the distance to translate
float trans[3];

// used to find the maximum dimension of the ship to scale it
// 100 long
float xmax = 0.0, xmin = 0.0, ymax = 0.0;
float ymin = 0.0,  zmax =0.0, zmin = 0.0;
float xdif, ydif, zdif, big, scale;

float maxx = -50.0, maxy = -50.0, maxz = -50.0;
float minx = 50.0, miny = 50.0, minz = 50.0;

// crossProduct() returns the x, y, and z values of the cross 
// product though these globals
float crossx, crossy, crossz;

//camera position in space
float cameraP[3] = {40.0, 5.0, 0.0} ;

float carP[3] = {0.0, 0.0, 0.0};
float carLook[3] = {-1.0, 0.0, 0.0};

//unit vector for the direction the camera looks in
float look[3] = {-1.0, 0.0, 0.0};

//unit vector for the up direction of the camera
float up[3] = {0.0, 1.0, 0.0};
             

// holds the contents of the coord and poly file
float coora[20000][3];
float polya[20000][200];

float coorm[2100][3];
float polym[3500][5];

// holds the normal vector for each polygon and vertex
float coorn[20000][3];
float polyn[20000][3];

float coormn[2100][3];
float polymn[3500][3];

// the length of the polyfile
int polyLength;
int polymLength;

//Represents a terrain, by storing a set of heights and normals at 2D locations
class Terrain {
	private:
		int w; //Width
		int l; //Length
		float** hs; //Heights
	public:
		Terrain(int w2, int l2) {
			w = w2;
			l = l2;
			
			hs = new float*[l];
			for(int i = 0; i < l; i++) {
				hs[i] = new float[w];
			}		
		}
		~Terrain() {
			for(int i = 0; i < l; i++) {
				delete[] hs[i];
			}
			delete[] hs;
		}
		int width() {
			return w;
		}
		int length() {
			return l;
		}
		//Sets the height at (x, z) to y
		void setHeight(int x, int z, float y) {
			hs[z][x] = y;
			//computedNormals = false;
		}
		//Returns the height at (x, z)
		float getHeight(int x, int z) {
			return hs[z][x];
		}
};	

Terrain* ground;

Terrain* loadTerrain(const char* filename, float height) {
	Image* image = loadBMP(filename);
	Terrain* t = new Terrain(image->width, image->height);
	for(int y = 0; y < image->height; y++) {
		for(int x = 0; x < image->width; x++) {
			unsigned char color =
				(unsigned char)image->pixels[3 * (y * image->width + x)];
			float h = height * ((color / 255.0f) - 0.5f);
			t->setHeight(x, y, h);
		}
	}
	delete image;
	//t->computeNormals();
	return t;
}

void cleanup() {
	delete ground;
}

//makes an image into a texture. found on www.videotutorialsrock.com
GLuint loadTexture(Image *image){
	GLuint texID;
	glGenTextures(1, &texID);  //make room for texture
	//tells opengl which texture to edit
	glBindTexture(GL_TEXTURE_2D, texID);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, image->width,
		         image->height, 0, GL_RGB, GL_UNSIGNED_BYTE,
				 image->pixels);
	return texID;
}

//loads the skybox textures.
GLuint loadSkyTex(Image *image){
	GLuint skybox;
	glGenTextures(1, &skybox);
	glBindTexture(GL_TEXTURE_2D, skybox);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, image->width,
		         image->height, 0, GL_RGB, GL_UNSIGNED_BYTE,
				 image->pixels);
	return skybox; 
}

void findNormals(float px, float pz, float *pntr) {
   px /= 40.0;
   px += 30.0;
   pz /= 40.0;
   pz += 30.0;
   int x = (int)px, z = (int)pz;
   if(px < 0.0f || pz < 0.0f || px > 59.0f || pz > 59.0f){
      pntr[0] = 0.0f;
      pntr[1] = 1.0f;
      pntr[2] = 0.0f; 
   } else {
      pntr[0] = landn[x][z][0];
      pntr[1] = landn[x][z][1];
      pntr[2] = landn[x][z][2];
   }
}

float findHeights(float px, float pz) {
   px /= 40.0;
   px += 30.0;
   pz /= 40.0;
   pz += 30.0;
   if(px < 0.0f || pz < 0.0f || px > 59.0f || pz > 59.0f){
      return 0.0f;
   }
   float d1, d2;
   int x = (int) px;
   int z = (int) pz;
   d1 = sqrt(pow(px - x, 2) + pow(pz - z, 2)); //closer to original
   d2 = sqrt(pow(x + 1 - px, 2) + pow(z + 1 - pz, 2));//closer to the 
                                                      // other corner
   if(d1 < d2) {
      float result = ground->getHeight(x, z);
      result += (px - (float)x)*(ground->getHeight(x+1, z) - 
                                 ground->getHeight(x,z));
      result += (pz - (float)z)*(ground->getHeight(x, z+1) - 
                                 ground->getHeight(x,z));
      return result * 10.0f;
   }
   else {
      float result = ground->getHeight(x+1, z+1);
      result += ((float)(x+1) - px)*(ground->getHeight(x, z+1) - 
                                     ground->getHeight(x+1,z+1));
      result += ((float)(z+1) - pz)*(ground->getHeight(x+1, z) - 
                                     ground->getHeight(x+1,z+1));
      return result * 10.0f;
   }
}

void printFiles(void) {
   int index, coorI;
   printf("\n\npolys %d\n", (int)polyLength);
   for(index = 0; index <= (int)polyLength; index++) {
      printf("%d: ", (int)index);
      for(coorI = 0; coorI <= polya[index][0]; coorI++) {
         printf("%d ", (int)polya[index][coorI]);
      }
      printf("\n");
   }
   printf("\n\ncoords %d\n", (int)coorLength);
   for(coorI = 0; coorI < (int)coorLength; coorI++) {
      printf("%d: %f, %f, %f\n", coorI, coora[coorI][0], coora[coorI][1], coora[coorI][2]);
   }
}

// calculates the cross product of two vectors
// and stores the result in crossx, crossy, crossz
void crossProduct(float x, float y, float z, float x2, float y2,
                   float z2) {   
   crossx = y * z2 - z * y2;
   crossy = z * x2 - x * z2;
   crossz = x * y2 - y * x2; 
   float length = crossx*crossx + crossy*crossy + crossz*crossz;
   length = sqrt(length);
   crossx /= length;
   crossy /= length;
   crossz /= length;
}

// establishes the lighting
void lighting(void) {
   glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
   glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
   glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position); 
   glEnable(GL_LIGHT0);
   glEnable(GL_LIGHTING);

}

// draws the three planes
void drawPlanes(void) {
   int i, j;
   float temp[3] = {0.0, 0.0, 0.0};
   if(drawNormal) {
      for(i = -800; i <= 800; i += 100) {
         for(j = -800; j <= 800; j += 100) {
            temp[0] = ((float)i)/1600.0;
            temp[1] = ((float)j)/1600.0; 
            temp[2] = 0.5;
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, temp);
            glBegin(GL_LINES);
            glVertex3f((float)i, 0.0, (float)j);
            glVertex3f((float)i, 10.0, (float)j);
            glEnd();
         }
      }
   }
   
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, one3);
   
   glEnable(GL_TEXTURE_2D);
   glBindTexture(GL_TEXTURE_2D, _texID);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
   //glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, green3);
   glBegin(GL_QUADS);
	   glNormal3f(0.0, 1.0, 0.0);
	   glTexCoord2f(0.0f, 0.0f);
	   glVertex3f(-800.0, 0.0, -800.0);
	   glTexCoord2f(1.0f, 0.0f);
	   glVertex3f(-800.0, 0.0, 800.0);
	   glTexCoord2f(1.0f, 1.0f);
	   glVertex3f(800.0, 0.0, 800.0);
	   glTexCoord2f(0.0f, 1.0f);
	   glVertex3f(800.0, 0.0, -800.0);
   glEnd();
   //no more textures...
   glDisable(GL_TEXTURE_2D);
   
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
}

// redraws the screen
void idle(void) {
   if(speed < 0.008*XWIN && speed >= -0.008*XWIN)
      speed = 0.0;
   if(speed > 0.008*XWIN) 
      speed -= 0.008*XWIN;
   else if (speed < -0.008*XWIN)
      speed += 0.008*XWIN;
   if (pressW && speed < 5.0*XWIN)
      speed += (5.0*XWIN - speed) * .05*XWIN;
   else if(pressS) {
      if(speed < .03*XWIN && speed > -.03*XWIN)
         speed = 0.0;
      if(speed > .03*XWIN)
         speed -= .03*XWIN;
      else if(speed < -.03*XWIN)
         speed += .03*XWIN;
   } else if(pressX) {
      if(speed <= 0.0 && speed > -3.0*XWIN)
         speed -= (speed + 3.0*XWIN) * .02*XWIN;  
   }
   
   
   trans[0] += carLook[0] * speed;
   
   trans[2] += carLook[2] * speed;
   trans[1] = findHeights(trans[0], trans[2]);
   wheelSpin += speed/(17.369729*2.0*3.14159265)*360.0;
   if(wheelSpin < 0.0)
      wheelSpin += 360.0;
   if(wheelSpin > 360.0)
      wheelSpin -= 360.0;

   if(!(pressA || pressD) && turn < .002*XWIN && turn > -.002*XWIN)
      turn = 0.0;
   if(!(pressA || pressD) && turn < -.002*XWIN)
      turn += .002*XWIN;
   else if (!(pressA || pressD) && turn > .002*XWIN)
      turn -= .002*XWIN;
   if(pressA) {
      if(turn < 0.05)
         turn += 0.003*XWIN;
   } else if(pressD) {
      if(turn > -0.05)
         turn -= 0.003*XWIN;
   }
   if(turn < -.001 || turn > .001) {
      float x = cos(0.8*turn * speed/6.0 + 3.14159265358979323846/2.0);
      float y = sin(0.8*turn * speed/6.0 + 3.14159265358979323846/2.0);
      crossProduct(carLook[0], carLook[1], carLook[2], up[0], up[1], up[2]); 
      carLook[0] = carLook[0] * y + crossx * x;
      carLook[1] = carLook[1] * y + crossy * x;
      carLook[2] = carLook[2] * y + crossz * x;
      float length = sqrt(carLook[0]*carLook[0] + carLook[1]*carLook[1] + 
                          carLook[2]*carLook[2]);
      carLook[0] /= length;
      carLook[1] /= length;
      carLook[2] /= length;
      crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
      look[0] = look[0] * y + crossx * x;
      look[1] = look[1] * y + crossy * x;
      look[2] = look[2] * y + crossz * x;
      length = sqrt(look[0]*look[0] + look[1]*look[1] +
                          look[2]*look[2]);
      look[0] /= length;
      look[1] /= length;
      look[2] /= length;
      
      rotateY = -atan2(carLook[2], carLook[0]) * 57.2957795 + 180.0;
      
   }
   glutPostRedisplay();
   XSLEEP
}



// draw the object
void drawCar(void) {
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
      
   for(index = 0; index <= (int)polyLength; index++) {   
      switch(index) {
         case 0:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//cover
            break;
         case 237:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//visor
            break;
         case 339:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 340:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 347:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 354:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 366:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 367:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 369:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 371:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 373:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 375:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 337:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 378:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 379:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 386:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 393:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 405:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//dark
            break;
         case 406:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 408:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 410:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 412:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 414:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 416:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//black
            break;
         case 417:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//mirror   
            break;
         case 535:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//logo
            break;
         case 1065:
            index = 1660;
            continue;
         case 1661:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3);//interior
            break;
         case 1727:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//handles
            break;
         case 2139:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2142:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 2143:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2146:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 2148:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2150:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 2151:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2158:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom  
            break;
         case 2159:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 2171:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3);//hlight 
            break;
         case 2172:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 2197:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3);//hlight
           break;
         case 2232:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 2234:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2235:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 2250:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2264:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 2266:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2288:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 2289:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 2310:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 2336:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 2361:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3);//fseat
            break;
         case 2566:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3);//bseat
            break;
         case 2712:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3);//interior
            break;
         case 2898:
			if(pressS)
				glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);
			else
                glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3);//rlight
            break;
         case 2914:
            if(pressS)
				glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);
			else
                glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3);//wlight
            break;
         case 2916:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 2917:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 2918:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//sidep
            break;
         case 2919:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 2921:   
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 2923:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 2924:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 2929:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//sidep
            break;
         case 2930:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 2931:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 2940:
            if(noglass) {
               index = 2955;
               continue;
            }
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//glass
            break;
         case 2956:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3002:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//sidep
            break;
         case 3007:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3008:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3013:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 3028:
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3047:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3049:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3052:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3053:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3056:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3058:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3060:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3061:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3068:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3069:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//black
            break;
         case 3081:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3);//hlight
            break;
         case 3082:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//net
            break;
         case 3107:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3);//hlight
            break;
         case 3142:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3144:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3145:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3160:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3174:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3176:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3198:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//hood
            break;
         case 3199:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3220:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//hood
            break;
         case 3246:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3271:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3);//fseat
            break;
         case 3476:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3);//bseat
            break;
         case 3622:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3);//interior
            break;
         case 3788:
            if(pressS)
				glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);
			else
                glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3);//rlight
            break;
         case 3804:
            if(pressS)
				glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);
			else
                glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3);//wlight
            break;
         case 3806:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3807:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3808:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//sidep
            break;
         case 3809:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 3811:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3813:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 3814:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3819:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//sidep
            break;
         case 3820:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3821:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 3830:
            if(noglass) {
               index = 3845;
               continue;
            }
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//glass
            break;
         case 3846:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3892:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//sidep
            break;
         case 3897:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 3898:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3903:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//trunk
            break;
         case 3918:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 3937:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//orn
            break;
         case 3939:
            index = 5474;   
            continue;
            break;
         case 5475:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5478:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 5479:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5480:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5484:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5487:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5498:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5501:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5509:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5511:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5514:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5515:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5516:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5517:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5518:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5519:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 5522:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5525:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 5526:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5527:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5531:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5534:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5545:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5548:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5556:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5558:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5561:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5562:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5563:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5564:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//doors
            break;
         case 5565:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3);//trim
            break;
         case 5566:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3);//bottom
            break;
         case 5569:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3);//alight
            break;
         case 5697:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3);//interior
            break;
         case 5700:
            if(noglass) {
               index = 5703;
               continue;
            }
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//glass
            break;
         case 5704:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3);//interior
            break;
         case 5712:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5713:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5714:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5715:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5716:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5717:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5718:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5720:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5722:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5723:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5724:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5725:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5726:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5728:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5729:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5730:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5731:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5733:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5734:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5735:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5737:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5738:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5740:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5741:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5742:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5743:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//embwhite
            break;
         case 5744:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//embred
            break;
         case 5745:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3);//embblue
            break;
         case 5746:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//rubber
            break;
         case 5906:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3);//blacko
            break;
         case 6386:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3);//grill
            break;
         case 7917:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3);//body
            break;
         case 8565:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3);//blue
            break;
         case 12001:
            index = (int)polyLength + 5;
            continue;
            break;
         //
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

void drawSteer(void) {
   glTranslatef(3.243832,  0.499045, -1.303851);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   // draw the tires itself
   for(index = 1065; index <= (int)polyLength; index++) { 
      switch(index) {
         case 1065:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//steer1
            break;
         case 1385:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3);//steer2
            break;
         case 1581:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3);//steer1
            break;
         case 1661:
            index = (int)polyLength;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

// draw front tires
void drawRightTire(void) {
   glTranslatef(4.498000, 1.739000, 2.524804);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   // draw the tires itself
   for(index = 3939; index <= (int)polyLength; index++) { 
      switch(index) {
         case 3939:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 3941:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 3942:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 3953:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 3954:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 3965:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 3966:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 3977:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 3978:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 3989:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 3990:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4001:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4002:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4013:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhtiew
            break;
         case 4014:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4025:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4026:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4037:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhtiew
            break;
         case 4038:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4049:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4050:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4061:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4062:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4073:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4074:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4085:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4086:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4097:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4098:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4109:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4110:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4121:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4122:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4133:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4134:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4145:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4146:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4157:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4158:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4169:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4170:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4181:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4182:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4193:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4194:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4205:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4206:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4217:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//rfwhitew
            break;
         case 4218:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4229:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4230:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4241:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4242:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4253:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4254:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4265:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4266:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4277:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4278:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4289:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4290:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4301:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4302:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4313:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//rfwhitew
            break;
         case 4314:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//rftire
            break;
         case 4323:
            index = 13484;
            continue;
         case 13485:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3);//rfrim   
            break;
         case 14227:
            index = (int)polyLength + 5;
            continue;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
         
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

// draw front tires
void drawLeftTire(void) {
   glTranslatef(4.498000, 1.739000, -2.524804);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   
   // draw the tires itself
   for(index = 4707; index <= (int)polyLength; index++) { 
      switch(index) {
         case 4707:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4709:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4710:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4721:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4722:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4733:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4734:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4745:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4746:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4757:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4758:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4769:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4770:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4781:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4782:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4793:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4794:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4805:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4806:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4817:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4818:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4829:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4830:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4841:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4842:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4853:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4854:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4865:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4866:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4877:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4878:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4889:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4890:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4901:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4902:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4913:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4914:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4925:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4926:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4937:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4938:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4949:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4950:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4961:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4962:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4973:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4974:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4985:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//lfwhitew
            break;
         case 4986:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 4997:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 4998:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5009:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5010:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5021:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5022:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5033:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5034:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5045:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5046:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5057:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5058:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5069:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5070:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5081:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//lfwhitew
            break;
         case 5082:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//lftires
            break;
         case 5091:
            index = 12000;
            continue;
         case 12001:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3);//lfrim
            break;
         case 12743:
            index = (int)polyLength + 3;
            continue;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
                  
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}



// draw rear tires
void drawRearTires(void) {
   glTranslatef(-5.048674, 1.739000, 0.0);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   if(choice3) {
      choice3 = 0;
      choice2 = 1;
   }
   
   // draw the tires itself
   for(index = 4323; index <= (int)polyLength; index++) { 
      switch(index) {
         case 4323:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4325:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4326:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4337:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4338:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4349:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4350:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4361:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4362:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4373:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4374:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4385:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4386:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4397:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4398:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4409:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4410:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4421:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4422:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4433:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4434:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4445:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4446:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4457:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4458:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4469:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4470:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4481:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4482:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4493:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4494:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4505:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4506:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4517:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4518:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4529:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4530:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4541:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4542:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4553:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4554:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4565:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4566:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4577:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4578:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4589:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4590:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4601:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 4602:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4613:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4614:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4625:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4626:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4637:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4638:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4649:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4650:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4661:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4662:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4673:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4674:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4685:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4686:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4697:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 4698:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 4707:
            choice2 = 0;
            index = 5090;
            continue; 
            break;
         case 5091:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5093:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5094:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5105:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5106:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5117:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5118:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5129:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5130:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5141:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5142:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5153:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5154:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5165:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5166:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5177:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5178:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5189:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5190:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5201:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5202:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5213:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5214:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5225:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5226:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5237:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5238:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5249:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5250:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5261:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5262:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5273:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5274:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5285:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5286:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5297:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5298:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5309:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5310:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5321:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5322:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5333:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5334:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5345:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5346:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5357:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5358:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5369:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3);//bwhitew
            break;
         case 5370:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5381:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5382:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5393:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5394:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5405:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5406:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5417:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5418:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5429:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5430:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5441:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5442:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5453:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5454:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires
            break;
         case 5465:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3);//bwhitew
            break;
         case 5466:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3);//btires  TIRE END
            break;
         case 5475:
            index = 12742;
            continue;
         case 12743:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3);//brim    
            break;
         case 13485:
            index = 14226;
            continue;   
         case 14227:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3);//brim
            break;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {         
         int point = (int)polya[index][coorI];
         if(choice2) {
            if(maxx < coora[point][0])
               maxx = coora[point][0];
            if(minx > coora[point][0])
               minx = coora[point][0];
            if(maxy < coora[point][1])
               maxy = coora[point][1];
            if(miny > coora[point][1])
               miny = coora[point][1];
            if(maxz < coora[point][2])
               maxz = coora[point][2];
            if(minz < coora[point][2])
               minz = coora[point][2]; 
         }
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   if(choice1) {
      choice1 = 0;
      printf("maxx %f, minx %f, maxy %f, miny %f, maxz %f, minz %f\n", maxx*scale*scaler, minx, maxy, miny, maxz, minz);
      printf("\navgx %f, avgy %f avgz %f\n\n", (maxx + minx)/2.0, (maxy + miny)/2.0, (maxz + minz)/2.0  );
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

void drawMan(void) {
   //glTranslatef(-5.048674, 1.739000, 0.0);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   //printf("polymlength %d\n", (int)polymLength);
   // draw the tires itself
   for(index = 0; index <= (int)polymLength; index++) { 
      switch(index) {
         case 0:
            glMaterialfv(GL_FRONT, GL_EMISSION, tan3);//man
            break;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polym[index][0]; coorI++) {
                  
         int point = (int)polym[index][coorI];
         //printf("%d man[%d]: (%f, %f, %f)\n", index, point, coorm[point][0], coorm[point][1], coorm[point][3]); 
         
         //glNormal3f(coormn[point][0], coormn[point][1], coormn[point][2]);
         glVertex3f(coorm[point][0], coorm[point][1], coorm[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_EMISSION, zero3);
} 

void manVectors(void) {
  return;
}


// Calculates all the normal vectors
void polyVectors(void) {
   int index, coorI;
   fflush(stdout);
   for(index = 0; index < polyLength; index++ ) {
      coorn[index][0] = coorn[index][1] = coorn[index][2] = 0.0;
   }
   //printf("\n\n\n");
   //find and normalizes the normal vector for each polygon
   for(index = 0; index < (int)polyLength; index++) {
      int c0 = (int)polya[index][1];
      int c1 = (int)polya[index][2];
      int c2 = (int)polya[index][3];
      float x1, y1, z1, x2, y2, z2;
      x1 = coora[c0][0] - coora[c1][0];
      y1 = coora[c0][1] - coora[c1][1];
      z1 = coora[c0][2] - coora[c1][2];
      x2 = coora[c2][0] - coora[c1][0];
      y2 = coora[c2][1] - coora[c1][1];
      z2 = coora[c2][2] - coora[c1][2];
      crossProduct(x2, y2, z2,  x1, y1, z1);
      polyn[index][0] = crossx;
      polyn[index][1] = crossy;
      polyn[index][2] = crossz;
   }
   
   // for every polygon, adds that polygons normal vector
   // to the normal vector of each vertex in that polygon
   for(index = 0; index < (int)polyLength; index++) {
      for(coorI = 1; coorI < polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         coorn[point][0] += polyn[index][0];
         coorn[point][1] += polyn[index][1];
         coorn[point][2] += polyn[index][2];
      }
   }
   
   // normalizes each vertex's normal
   for(index = 1; index <= coorLength ; index++) {
      float length = sqrt(coorn[index][0]*coorn[index][0] +
                          coorn[index][1]*coorn[index][1] +
                          coorn[index][2]*coorn[index][2]);
      coorn[index][0] /= length;
      coorn[index][1] /= length;
      coorn[index][2] /= length;
   }
}

// Calculates all the normal vectors
void landVectors(void) {
   int index, coorI, z, x;
   for(z = 0; z < ground->length(); z++) {
		for(x = 0; x < ground->width(); x++) {
         landn[x][z][0] = landn[x][z][1] = landn[x][z][2] = 0.0;
      }
   }

   //find and normalizes the normal vector for each polygon
   for(z = 0; z < ground->length() - 1; z++) {
		float x1, y1, z1, x2, y2, z2;
      for(x = 0; x < ground->width() - 1; x++) {
         x1 = 0.0;
         y1 = ground->getHeight(x, z+1)*5 - ground->getHeight(x, z)*5;
         z1 = 40.0;
         x2 = 40.0;
         y2 = ground->getHeight(x+1, z)*5 - ground->getHeight(x, z)*5;
         z2 = 0.0;
         crossProduct(x2, y2, z2,  x1, y1, z1);
         landp[x][z][0][0] = crossx;
         landp[x][z][0][1] = crossy;
         landp[x][z][0][2] = crossz;
         
         x1 = 0.0;
         y1 = ground->getHeight(x+1, z)*10 - ground->getHeight(x+1, z+1)*10;
         z1 = -40.0;
         x2 = -40.0;
         y2 = ground->getHeight(x, z+1)*10 - ground->getHeight(x+1, z+1)*10;
         z2 = 0.0;
         crossProduct(x2, y2, z2,  x1, y1, z1);
         landp[x][z][1][0] = crossx;
         landp[x][z][1][1] = crossy;
         landp[x][z][1][2] = crossz;
      }
   }
   // for every polygon, adds that polygons normal vector
   // to the normal vector of each vertex in that polygon
   for(z = 0; z < ground->length() - 1; z++) {
      for(x = 0; x < ground->width() - 1; x++) {
         landn[x][z][0] += landp[x][z][0][0]; 
         landn[x][z][1] += landp[x][z][0][1];
         landn[x][z][2] += landp[x][z][0][2];
         landn[x + 1][z][0] += landp[x][z][0][0]; 
         landn[x + 1][z][1] += landp[x][z][0][1];
         landn[x + 1][z][2] += landp[x][z][0][2];
         landn[x][z + 1][0] += landp[x][z][0][0]; 
         landn[x][z + 1][1] += landp[x][z][0][1];
         landn[x][z + 1][2] += landp[x][z][0][2];
         landn[x + 1][z + 1][0] += landp[x][z][1][0]; 
         landn[x + 1][z + 1][1] += landp[x][z][1][1];
         landn[x + 1][z + 1][2] += landp[x][z][1][2];
         landn[x + 1][z][0] += landp[x][z][1][0]; 
         landn[x + 1][z][1] += landp[x][z][1][1];
         landn[x + 1][z][2] += landp[x][z][1][2];
         landn[x][z + 1][0] += landp[x][z][1][0]; 
         landn[x][z + 1][1] += landp[x][z][1][1];
         landn[x][z + 1][2] += landp[x][z][1][2];
      }
   }
   
   // normalizes each vertex's normal
   for(z = 0; z < ground->length(); z++) {
		for(x = 0; x < ground->width(); x++) {
         float length = sqrt(landn[x][z][0]*landn[x][z][0] +
                             landn[x][z][1]*landn[x][z][1] +
                             landn[x][z][2]*landn[x][z][2]);
         landn[x][z][0] /= length;
         landn[x][z][1] /= length;
         landn[x][z][2] /= length;
         
      }
   }
}


void drawLand(void) {
glTranslatef(0.0f, 0.0f, -10.0);
	glTranslatef(-(float)(ground->width() - 1) * 40 / 2,
				 0.0f,
				 -(float)(ground->length() - 1) * 40 / 2);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, zero3); 
	float temp[3] = {0.0, 0.6, 0.0};
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, one3);
   
   glEnable(GL_TEXTURE_2D);
   glBindTexture(GL_TEXTURE_2D, _texID);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
   float alternate = 0.0f;
	for(int z = 0; z < ground->length() - 1; z++) {
		glBegin(GL_TRIANGLE_STRIP);
		for(int x = 0; x < ground->width(); x++) {
		   alternate = 1.0f - alternate;
		   temp[0] = 0.9 * (ground->getHeight(x, z)+10.0)/20.0;
		   temp[2] = 0.9 * (ground->getHeight(x, z)+10.0)/20.0;
		   temp[1] = 0.2 + 0.8*((ground->getHeight(x, z)+10.0)/20.0);
		   glMaterialfv(GL_FRONT, GL_DIFFUSE, temp);
			glNormal3f(-landn[x][z][0], -landn[x][z][1], -landn[x][z][2]);
			glTexCoord2f(0.0f, 1.0f- alternate);
			glVertex3f(x*40, ground->getHeight(x, z)*10, z*40);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, temp);
			glNormal3f(-landn[x][z+1][0], -landn[x][z+1][1], -landn[x][z+1][2]);
			glTexCoord2f(1.0f, alternate);
			glVertex3f(x*40, ground->getHeight(x, z + 1)*10, (z + 1)*40);
		}
		glEnd();
	}
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3);
	temp[0] = 0.0;
	temp[1] = 0.0;
	temp[2] = 0.0;
	if(drawNormal) {
      for(int z = 0; z < ground->length(); z++) {
         glBegin(GL_LINES);
	      for(int x = 0; x < ground->width(); x++) {
		      temp[0] = ((float)x)/ground->width();
            temp[1] = ((float)z)/ground->length(); 
            temp[2] = 0.5;
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, temp);
			   glVertex3f(x*40 - landn[x][z][0]*40, 
			              ground->getHeight(x, z)*10 - landn[x][z][1]*10, 
			              z*40 - landn[x][z][2]*40);
			   glVertex3f(x*40, ground->getHeight(x, z)*10, z*40);
		   }
		   glEnd();
	   }
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, zero3);
}

void drawSky(void){

	//glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, one3);


	//front
	   glBindTexture(GL_TEXTURE_2D, _skybox[2]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(-240.0f, 240.0f, -240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, 240.0f, -240.0f);
	glEnd();

	//left
	   glBindTexture(GL_TEXTURE_2D, _skybox[1]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, 240.0f, -240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, 240.0f, 240.0f);
	glEnd();

	//back
      glBindTexture(GL_TEXTURE_2D, _skybox[0]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, 240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(-240.0f, 240.0f, 240.0f);
	glEnd();

	//right
	   glBindTexture(GL_TEXTURE_2D, _skybox[3]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(-240.0f, 240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(-240.0f, 240.0f, -240.0f);
	glEnd();

	//top
	   glBindTexture(GL_TEXTURE_2D, _skybox[4]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, 240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, 240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, 240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, 240.0f, -240.0f);
	glEnd();

	//bottom
	   glBindTexture(GL_TEXTURE_2D, _skybox[5]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, -240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, -240.0f, -240.0f);
	glEnd();
}
// draws the screen and handles translations/rotations/scales
void display(void) {
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glPushMatrix();
   
   // set the camera position
   if(!driverview) {
      
      crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
      if(!drawGround){ //just planes
         gluLookAt(trans[0] + cameraDistance*look[0]*cos(cameraDegree) +
                              cameraDistance*crossx*sin(cameraDegree), 
                   8.353187 + cameraUp, 
                   trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                              cameraDistance*crossz*sin(cameraDegree), 
                   trans[0], 
                   8.353187, 
                   trans[2],  
                  up[0], up[1], up[2]);    
      } else { //3d terrain time
         gluLookAt(trans[0] + cameraDistance*look[0]*cos(cameraDegree) +
                              cameraDistance*crossx*sin(cameraDegree), 
                   8.353187 + /*trans[1] +*/ cameraUp, 
                   trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                              cameraDistance*crossz*sin(cameraDegree), 
                   trans[0], 
                   /*trans[1]*/0.0, 
                   trans[2],  
                  up[0], up[1], up[2]);
      }
   } else { //are in driverview
   
      crossProduct(carLook[0], carLook[1], carLook[2], up[0], up[1], up[2]);
      if(!drawGround) {
         gluLookAt(trans[0] + -crossx*3.5 -2.8*carLook[0],
                   8.353187 + 4.0 , //driverc
                   trans[2] + -crossz*3.5 -2.8*carLook[2], 
                   trans[0] + -crossx*3.5 -1.8*carLook[0], 
                   8.353187 + 4.0, 
                   trans[2] + -crossz*3.5 -1.8*carLook[2],
                   up[0], up[1], up[2]);
      } else {
         gluLookAt(trans[0] + -crossx*3.5 -2.8*carLook[0],
                   trans[1] + 8.353187 + /*trans[1] + */4.0 , //driverc
                   trans[2] + -crossz*3.5 -2.8*carLook[2], 
                   trans[0] + -crossx*3.5 -1.8*carLook[0], 
                   8.353187 + /*trans[1]*/ + 4.0, 
                   trans[2] + -crossz*3.5 -1.8*carLook[2],
                   up[0], up[1], up[2]);
                   
      }
   }
   // establish lighting
   lighting();

   // draw the ground
   if(!drawGround){
      drawPlanes();
   }
   else{
      glPushMatrix();
      drawLand();
      glPopMatrix();
   }
   glPushMatrix();
   glScalef(3, 3, 3);
   //glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3);
    //glPushAttrib(GL_ENABLE_BIT);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	drawSky();
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	//glPopAttrib();
	glPopMatrix();
    //glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   // draw the ship
   glScalef(scale * scaler, scale * scaler, scale * scaler);
   if(!drawGround){
      glTranslatef(trans[0] / (scale * scaler), 
                   8.353187 / (scale * scaler), 
                   trans[2] / (scale * scaler));
   } else {
      glTranslatef(trans[0] / (scale * scaler), 
                   (trans[1]+8.353187) / (scale * scaler), 
                   trans[2] / (scale * scaler));
      float temp[3];
      findNormals(trans[0], 
                 trans[2],
                 temp);
      crossProduct(0.0f, 1.0f, 0.0f, -temp[0], -temp[1], -temp[2]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3);
      glBegin(GL_LINES);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(-temp[0]*10.0f, -temp[1]*10.0f, -temp[2]*10.0f);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(crossx*10.0f, crossy*10.0f, crossz*10.0f);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
      float adj = sqrt(pow(temp[2], 2)+pow(temp[0], 2));
      float thets = atan2(adj, temp[1]);
      thets *= 57.2957795f;
      glRotatef(-thets - 180.0f, crossx, crossy, crossz);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3);
      glBegin(GL_LINES);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(-10.0f, 0.0f, 0.0f);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(0.0f, 0.0f, 10.0f);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
      glEnd();
   }
   //glRotatef(rotateX, 1.0, 0.0, 0.0);
   glRotatef(rotateY, 0.0, 1.0, 0.0);
   //glRotatef(rotateZ, 0.0, 0.0, 1.0);
   
   if(drawChassis)
      drawCar();
   drawMan();
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -5.0);
      glVertex3f(0.0, 0.0, 5.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3);
      glVertex3f(5.0, 0.0, 0.0);
      glVertex3f(-5.0, 0.0, 0.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3);
      glVertex3f(0.0, 5.0, 0.0);
      glVertex3f(0.0, -5.0, 0.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   }

   //2.290254
   glPushMatrix();
   glTranslatef(-3.243832,  -0.499045, 1.303851);
   //glRotatef(90.0 - 19.2562621, 0.0, 0.0, 1.0);
   glRotatef(turn * 1000.0, 2.290254, 0.800073, 0.0);
   //glRotatef(-90.0 + 19.2562621, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -5.0);
      glVertex3f(0.0, 0.0, 5.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3);
      glVertex3f(5.0, 0.0, 0.0);
      glVertex3f(-5.0, 0.0, 0.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3);
      glVertex3f(0.0, 5.0, 0.0);
      glVertex3f(0.0, -5.0, 0.0); 
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   }
   drawSteer();
   glPopMatrix();

   glPushMatrix();
   glTranslatef(-4.498000, -1.739000, -2.524804);
   glRotatef(turn * 250.0, 0.0, 1.0, 0.0);
   glRotatef(wheelSpin, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -3.0);
      glVertex3f(0.0, 0.0, 3.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   }
   drawRightTire();
   
   glPopMatrix();
   
   glPushMatrix();
   glTranslatef(-4.498000, -1.739000, 2.524804);
   glRotatef(turn * 250.0, 0.0, 1.0, 0.0);
   glRotatef(wheelSpin, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -3.0);
      glVertex3f(0.0, 0.0, 3.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   }
   drawLeftTire();
   glPopMatrix();
   
   glPushMatrix();
   glTranslatef(5.048674, -1.739000, 0.0);
   glRotatef(wheelSpin, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -5.0);
      glVertex3f(0.0, 0.0, 5.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3);
   }
   drawRearTires();
   glPopMatrix();
   
   glPopMatrix();
   glutSwapBuffers();
}

// initalizes values before glut starts
void init(void) {
  //printFiles();
  glClearColor(0.0, 0.0, 0.8, 0.0);
  polyVectors();
  landVectors();
  manVectors();

  //loads skybox textures
  Image* front = loadBMP("front.bmp");
  _skybox[0] = loadSkyTex(front);
  //delete front;
  Image* left = loadBMP("left.bmp");
  _skybox[1] = loadSkyTex(left);
  //delete left;
  Image* back = loadBMP("back.bmp");
  _skybox[2] = loadSkyTex(back);
  //delete back;
  Image* right = loadBMP("right.bmp");
  _skybox[3] = loadSkyTex(right);
  //delete right;
  Image* top = loadBMP("up.bmp");
  _skybox[4] = loadSkyTex(top);
  //delete top;
  Image* bottom = loadBMP("down.bmp");
  _skybox[5] = loadSkyTex(bottom);
  //delete bottom;

  //this business loads the ground texture.
  Image* grass = loadBMP("ground2.bmp");
  _texID = loadTexture(grass);
  delete grass;


  glShadeModel(GL_SMOOTH);
  glPolygonMode(GL_FRONT, GL_FILL);
  glEnable(GL_DEPTH_TEST);
  //glEnable(GL_TEXTURE_2D);
  //glEnable(GL_COLOR_MATERIAL);
  glMatrixMode(GL_PROJECTION);
  gluPerspective(  110.0, 1.0, 1.0, 1001.0);
  glMatrixMode(GL_MODELVIEW);
  trans[0] = trans[2] = 0.0;
  trans[1] = findHeights(trans[0], trans[2]);
  ps[0][0] = ps[0][1] = ps[0][2] = ps[1][0] = ps[1][1] = ps[1][2] = 0.0;
}

// handles keyboard input
void keyboard(unsigned char key, int x, int y) {
   switch (key) {
      case 'r':
		 cameraUp = 10.0;
	     cameraDegree = 0.0;
		 cameraDistance = -35.0;
         trans[0] = 0.0;
         trans[1] = 8.353187;
         trans[2] = 0.0;
		 look[0] = -1.0;
		 look[1] = look[2] = 0.0;
         carLook[0] = -1.0;
	     carLook[1] = 0.0;
         carLook[2] = 0.0;
         up[0] = up[2] = 0.0;
         up[1] = 1.0;
		 turn = 0.0;
		 speed = 0.0;
         rotateX = 0.0;
         rotateY = 0.0;
         rotateZ = 0.0;
         break;
      case 'w':
         pressW = 1;
         break; 
      case 'a':
         pressA = 1;
         break;
      case 's':
         pressS = 1;
         break;
      case 'd':
         pressD = 1;
         break;
      case 'x':
         pressX = 1;
         break;
      case 'c':
         drawChassis = 1 - drawChassis;
         break;
      case 'v':
         driverview = 1 - driverview;
         break;
      case 'g':
         noglass = 1 - noglass;
         break;
      case 'i':
         partAxis = 1 - partAxis;
         break;
      case 'l':
         drawGround = 1 - drawGround;
         trans[1] = findHeights(trans[0], trans[1]);
         break;
      case 'n':
         drawNormal = 1 - drawNormal;
         break;
   }
}

// disables flags when keys are no longer pressed
void keyup(unsigned char key, int x, int y) {
   switch(key) {
      case 'p':
         printf("pressM %d, pressH %d, pressV %d\nclickM %d clickH %d clickV %d\n", pressM, pressH, pressV, clickM, clickH, clickV);
         break;
      case 'w':
         pressW = 0;
         break; 
      case 'a':
         pressA = 0;
         break;
      case 's':
         pressS = 0;
         break;
      case 'd':
         pressD = 0;
         break;
      case 'x':
         pressX = 0;
         break;  
      case 'm':
         pressM = 0;
         break;
      case 'v':
         pressV = 0;
         break;
      case 'h':
         pressH = 0;
         break;
   }
}

//handles mouse clicks
void mouseClick(int button, int state, int x, int y){
   if (state == GLUT_DOWN){
      xMouse = x;
      yMouse = -y;
      if (button == GLUT_RIGHT_BUTTON) {
         rightC = 1;
      } else if (button == GLUT_MIDDLE_BUTTON) {
         middleC = 1;
      } else if (button == GLUT_LEFT_BUTTON) {
         leftC = 1;
      }
   } else {
      if (button == GLUT_RIGHT_BUTTON) {
         rightC = 0;
      } else if (button == GLUT_MIDDLE_BUTTON) {
         middleC = 0;
      } else if (button == GLUT_LEFT_BUTTON) {
         leftC = 0;
      }
   }
}



// tracks active mouse motion
void motion(int x, int y){
   if (rightC) {
	   if((yMouse + y)/2.0 > -200.0 || -1.0 * cameraUp - 7.5 < (yMouse + y)/2.0) 
         cameraUp += (yMouse + y)/2.0;
      yMouse = -y;
   } else if (leftC) {
      cameraDegree += (xMouse - x)/50.0;
      xMouse = x;
   } else if (middleC) {
      cameraDistance += (yMouse + y)/2.0;
      if(cameraDistance >= 0.0)
         cameraDistance = -1.0;
      yMouse = -y;
   }
}

void reshape (int w, int h) {
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   width = w;
   hight = h;
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   gluPerspective(  110.0, (float)width/(float)hight, 1.0, 1001.0);
   glMatrixMode (GL_MODELVIEW);
}

int main(int argc, char **argv) {
   int index;
   // reads in the input files in a crazy c++ style
   int coorN = 0, pollyN = 0;

   ifstream coorIn ("chevy.coor" );
   coorIn >> coorLength;
   coorLength++;
   for(int i = 1; i <=coorLength; i++) {
      int n;
      char c;
      coorIn>>n>>c>>coora[i][0]>>c>>coora[i][1]>>c>>coora[i][2]; 
      if(coora[i][0] > xmax)
         xmax = coora[i][0];
      if(coora[i][0] < xmin)
         xmin = coora[i][0];
      if(coora[i][1] > ymax)
         ymax = coora[i][1];
      if(coora[i][1] < ymin)
         ymin = coora[i][1];
      if(coora[i][2] > zmax)
         zmax = coora[i][2];
      if(coora[i][2] < zmin)
         zmin = coora[i][2];      
   }
   xdif = xmax - xmin;
   ydif = ymax - ymin;
   zdif = zmax - zmin;
   big = xdif;
   if(ydif > big)
      big = ydif;
   if(zdif > big)
      big = zdif;
   scale = 100.0/big;
   ifstream polyIn ("chevy.poly" );
   polyIn >> polyLength;
   for(int i = 0; i <=polyLength; i++) {
      char line[1024];
      string name;
      int j = 1;
      
      polyIn.getline( line, 512);
      stringstream ss(stringstream:: in | stringstream:: out);
      ss << line;
      ss >> name;
      while(ss.good() ) {
         ss >> polya[i][j++];
      }
      polya[i][0] = j - 2;
             
   }
   
   //read in a man
   ifstream coormIn ("man.coor" );
   coormIn >> coormLength;
   coormLength++;
   printf("COORLENGTH %d\n", coormLength);
   for(int i = 1; i <=coormLength; i++) {
      int n;
      char c;
      coormIn>>n>>c>>coorm[i][0]>>c>>coorm[i][1]>>c>>coorm[i][2]; 
   }
   ifstream polymIn ("man.poly" );
   polymIn >> polymLength;
   for(int i = 0; i <=polymLength; i++) {
      char line[1024];
      string name;
      int j = 1;
      
      polymIn.getline( line, 512);
      stringstream ss(stringstream:: in | stringstream:: out);
      ss << line;
      ss >> name;
      while(ss.good() ) {
         ss >> polym[i][j++];
      }
      polym[i][0] = j - 2;
             
   }
   fflush(stdout);
   ground = loadTerrain("heightmap.bmp", 20); 
   // starts and runs glut
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
   glutInitWindowSize (500, 500); 
   glutInitWindowPosition (200, 100);
   glutCreateWindow(argv[0]);
   glutDisplayFunc(display);
   glutKeyboardFunc(keyboard);
   glutKeyboardUpFunc(keyup);
   glutMouseFunc(mouseClick);
   glutReshapeFunc(reshape);
   glutMotionFunc(motion);
   glutIdleFunc(idle);
   init();
   glutMainLoop();
   return 0;
}


