#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <GL/gl.h>
#include <stdio.h>
//#include "colors.h"
 
#define DARKNESS 0.75f

float whe3[2][4] = {{0.01, 0.01, 0.01, 1.0},
                    {0.01*DARKNESS, 0.01*DARKNESS, 0.01*DARKNESS, 1.0}};
float zero3[2][4] = {{0.0, 0.0, 0.0, 1.0},
                     {0.0, 0.0, 0.0, 1.0}};
float dark3[2][4] = {{0.1, 0.1, 0.1, 1.0},
                     {0.1*DARKNESS, 0.1*DARKNESS, 0.1*DARKNESS, 1.0}};
float half3[2][4] = {{0.5, 0.5, 0.5, 1.0},
                     {0.5*DARKNESS, 0.5*DARKNESS, 0.5*DARKNESS, 1.0}};
float dgrey3[2][4] = {{0.3, 0.3, 0.3, 1.0},
                      {0.3*DARKNESS, 0.3*DARKNESS, 0.3*DARKNESS, 1.0}};
float silver3[2][4] = {{0.8, 0.8, 0.8, 1.0},
                       {0.8*DARKNESS, 0.8*DARKNESS, 0.8*DARKNESS, 1.0}};
float grey3[2][4] = {{0.7, 0.7, 0.7, 1.0},
                     {0.7*DARKNESS, 0.7*DARKNESS, 0.7*DARKNESS, 1.0}};
float lgrey3[2][4] = {{0.5, 0.5, 0.5, 1.0},
                      {0.5*DARKNESS, 0.5*DARKNESS, 0.5*DARKNESS, 1.0}};
float one3[2][4] = {{1.0, 1.0, 1.0, 1.0},
                    {1.0*DARKNESS, 1.0*DARKNESS, 1.0*DARKNESS, 1.0}};
float transp[2][4] = {{1.0, 1.0, 1.0, 0.8},
                      {1.0*DARKNESS, 1.0*DARKNESS, 1.0*DARKNESS, 0.8}};
float transp2[2][4] = {{0.0, 0.0, 0.8, 0.4},
                      {0.0, 0.0, 0.8, 0.1}};
float clear[2][4] = {{1.0, 0.0, 0.0, 0.0},
                     {1.0, 0.0, 0.0, 0.2}};
//float red3[4] = {1.0, 0.01, 0.01, 1.0};
float red3[2][4] = {{1.0, 0.01, .01, 1.0},
                    {1.0*DARKNESS, 0.01*DARKNESS, 0.01*DARKNESS, 1.0}};
float lred3[2][4] = {{0.0, 0.2, 0.2, 1.0},
                     {0.0, 0.2*DARKNESS, 0.2*DARKNESS, 1.0}};
//float lred3[4] = {0.4, 0.1, 0.1, 1.0};
float dred3[2][4] = {{0.3, 0.0, 0.0, 1.0},
                     {0.3*DARKNESS, 0.0, 0.0, .50}};
float tan3[2][4] = {{0.6, 0.5, 0.4, 1.0},
                    {0.6*DARKNESS, 0.5*DARKNESS, 0.4*DARKNESS, 1.0}};
float green3[2][4] = {{0.0, 0.6, 0.0, 1.0},
                      {0.0, 0.6*DARKNESS, 0.0, 1.0}};
float blue3[2][4] = {{0.0, 0.0, 1.0, 1.0},
                     {0.0, 0.0, 1.0*DARKNESS, 1.0}};
float yellow3[2][4] = {{0.9, 0.9, 0.0, 1.0},
                       {0.9*DARKNESS, 0.9*DARKNESS, 0.0, 1.0}};
float rg3[2][4] = {{0.6, 0.6, 0.3, 1.0},
                   {0.6*DARKNESS, 0.6*DARKNESS, 0.3*DARKNESS, 1.0}};
float rb3[2][4] = {{0.6, 0.3, 0.6, 1.0},
                   {0.6*DARKNESS, 0.3*DARKNESS, 0.6*DARKNESS, 1.0}};
float gb3[2][4] = {{0.3, 0.6, 0.6, 1.0},
                   {0.3*DARKNESS, 0.6*DARKNESS, 0.6*DARKNESS, 1.0}};
float spray[2][4] = {{0.0, 0.0, 1.0, 0.4},
                     {0.0, 0.0, 1.0*DARKNESS, 0.4}};
float water4[2][4] = {{0.0, 0.0, 1.0, 1.0},
                      {0.0, 0.0, 1.0*DARKNESS, 1.0}};
GLfloat oneS[1] = {128};
GLfloat halfS[1] = {1};
GLfloat zeroS[1] = {0};
// draw rear tires
void drawRearTires(float coorn[20000][3], float coora[20000][3], float polya[20000][200], 
                   int night, float polyLength, float box[4][4][4][3], int usebox) {
   if(!usebox)
      glTranslatef(-5.048674, 1.739000, 0.0);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   // draw the tires itself
   for(index = 4323; index <= (int)polyLength; index++) { 
      switch(index) {
         case 4323:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4325:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4326:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4337:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4338:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4349:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4350:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4361:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4362:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4373:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4374:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4385:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4386:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4397:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4398:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4409:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4410:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4421:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4422:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4433:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4434:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4445:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4446:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4457:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4458:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4469:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4470:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4481:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4482:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4493:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4494:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4505:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4506:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4517:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4518:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4529:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4530:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4541:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4542:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4553:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4554:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4565:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4566:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4577:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4578:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4589:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4590:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4601:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 4602:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4613:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4614:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4625:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4626:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4637:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4638:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4649:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4650:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4661:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4662:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4673:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4674:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4685:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4686:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4697:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 4698:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 4707:
            index = 5090;
            continue; 
            break;
         case 5091:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5093:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5094:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5105:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5106:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5117:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5118:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5129:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5130:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5141:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5142:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5153:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5154:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5165:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5166:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5177:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5178:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5189:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5190:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5201:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5202:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5213:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5214:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5225:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5226:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5237:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5238:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5249:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5250:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5261:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5262:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5273:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5274:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5285:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5286:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5297:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5298:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5309:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5310:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5321:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5322:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5333:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5334:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5345:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5346:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5357:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5358:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5369:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//bwhitew
            break;
         case 5370:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5381:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5382:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5393:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5394:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5405:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5406:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5417:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5418:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5429:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5430:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5441:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5442:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5453:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5454:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires
            break;
         case 5465:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//bwhitew
            break;
         case 5466:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//btires  TIRE END
            break;
         case 5475:
            index = 12742;
            continue;
         case 12743:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3[night]);//brim    
            break;
         case 13485:
            index = 14226;
            continue;   
         case 14227:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3[night]);//brim
            break;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {         
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

// draw front tires
void drawLeftTire(float coorn[20000][3], float coora[20000][3], float polya[20000][200], int night, 
                  float polyLength, float box[4][4][4][3], int usebox) {
   if(!usebox)
      glTranslatef(4.498000, 1.739000, -2.524804);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   
   // draw the tires itself
   for(index = 4707; index <= (int)polyLength; index++) { 
      switch(index) {
         case 4707:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4709:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4710:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4721:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4722:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4733:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4734:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4745:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4746:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4757:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4758:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4769:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4770:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4781:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4782:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4793:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4794:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4805:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4806:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4817:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4818:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4829:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4830:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4841:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4842:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4853:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4854:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4865:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4866:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4877:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4878:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4889:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4890:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4901:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4902:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4913:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4914:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4925:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4926:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4937:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4938:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4949:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4950:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4961:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4962:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4973:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4974:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4985:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//lfwhitew
            break;
         case 4986:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 4997:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 4998:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5009:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5010:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5021:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5022:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5033:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5034:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5045:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5046:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5057:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5058:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5069:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5070:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5081:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//lfwhitew
            break;
         case 5082:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//lftires
            break;
         case 5091:
            index = 12000;
            continue;
         case 12001:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3[night]);//lfrim
            break;
         case 12743:
            index = (int)polyLength + 3;
            continue;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
                  
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

// draw front tires
void drawRightTire(float coorn[20000][3], float coora[20000][3], 
                   float polya[20000][200], int night, float polyLength, 
                   float box[4][4][4][3], int usebox) {
   if(!usebox)
      glTranslatef(4.498000, 1.739000, 2.524804);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   // draw the tires itself
   for(index = 3939; index <= (int)polyLength; index++) { 
      switch(index) {
         case 3939:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 3941:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 3942:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 3953:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 3954:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 3965:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 3966:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 3977:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 3978:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 3989:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 3990:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4001:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4002:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4013:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhtiew
            break;
         case 4014:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4025:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4026:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4037:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhtiew
            break;
         case 4038:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4049:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4050:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4061:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4062:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4073:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4074:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4085:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4086:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4097:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4098:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4109:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4110:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4121:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4122:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4133:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4134:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4145:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4146:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4157:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4158:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4169:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4170:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4181:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4182:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4193:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4194:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4205:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4206:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4217:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//rfwhitew
            break;
         case 4218:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4229:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4230:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4241:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4242:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4253:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4254:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4265:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4266:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4277:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4278:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4289:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4290:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4301:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4302:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4313:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lgrey3[night]);//rfwhitew
            break;
         case 4314:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, whe3[night]);//rftire
            break;
         case 4323:
            index = 13484;
            continue;
         case 13485:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3[night]);//rfrim   
            break;
         case 14227:
            index = (int)polyLength + 5;
            continue;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
         
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

void drawSteer(float coorn[20000][3], float coora[20000][3], 
               float polya[20000][200], int night, float polyLength, 
               float box[4][4][4][3], int usebox) {
   if(!usebox)
      glTranslatef(3.243832,  0.499045, -1.303851);
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
   
   // draw the tires itself
   for(index = 1065; index <= (int)polyLength; index++) { 
      switch(index) {
         case 1065:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//steer1
            break;
         case 1385:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3[night]);//steer2
            break;
         case 1581:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//steer1
            break;
         case 1661:
            index = (int)polyLength;
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

// draw the object
void drawCar(float coorn[20000][3], float coora[20000][3], float polya[20000][200],
             int night, float polyLength, int hlight, 
             int pressS, int noglass, float box[4][4][4][3], int usebox) {
   glMaterialfv(GL_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, half3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   //glMaterialfv(GL_BACK, GL_SHININESS, oneS);
   int index, coorI;
      
   for(index = 0; index <= (int)polyLength; index++) {   
      switch(index) {
         case 0:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//cover
            break;
         case 237:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//visor
            break;
         case 339:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 340:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 347:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 354:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 366:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 367:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 369:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 371:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 373:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 375:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 337:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 378:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 379:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 386:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 393:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 405:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//dark
            break;
         case 406:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 408:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 410:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 412:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 414:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 416:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//black
            break;
         case 417:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//mirror   
            break;
         case 535:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//logo
            break;
         case 1065:
            index = 1660;
            continue;
         case 1661:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3[night]);//interior
            break;
         case 1727:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//handles
            break;
         case 2139:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2142:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 2143:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2146:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 2148:
           glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2150:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 2151:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2158:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom  
            break;
         case 2159:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 2171:
            if(hlight)
               glMaterialfv(GL_FRONT, GL_EMISSION, yellow3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3[night]);//hlight 
            break;
         case 2172:
            glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 2197:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3[night]);//hlight
            if(hlight)
               glMaterialfv(GL_FRONT, GL_EMISSION, yellow3[night]);
            break;
         case 2232:
            glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 2234:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2235:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 2250:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2264:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 2266:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2288:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 2289:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 2310:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 2336:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 2361:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3[night]);//fseat
            break;
         case 2566:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3[night]);//bseat
            break;
         case 2712:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3[night]);//interior
            break;
         case 2898:
			   if(pressS)
				   glMaterialfv(GL_FRONT, GL_EMISSION, red3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3[night]);//rlight
            break;
         case 2914:
            if(pressS)
				   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);
	   		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3[night]);//wlight
            break;
         case 2916:
            glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 2917:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 2918:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//sidep
            break;
         case 2919:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 2921:   
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 2923:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 2924:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 2929:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//sidep
            break;
         case 2930:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 2931:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 2940:
            if(noglass) {
               index = 2955;
               continue;
            }
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//glass
            break;
         case 2956:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3002:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//sidep
            break;
         case 3007:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3008:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3013:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 3028:
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3047:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3049:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3052:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3053:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3056:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3058:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3060:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3061:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3068:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3069:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//black
            break;
         case 3081:
            if(hlight)
               glMaterialfv(GL_FRONT, GL_EMISSION, yellow3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3[night]);//hlight
            break;
         case 3082:
            glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//net
            break;
         case 3107:
            if(hlight)
               glMaterialfv(GL_FRONT, GL_EMISSION, yellow3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3[night]);//hlight
            break;
         case 3142:
            glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3144:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3145:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3160:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3174:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3176:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3198:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//hood
            break;
         case 3199:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3220:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//hood
            break;
         case 3246:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3271:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3[night]);//fseat
            break;
         case 3476:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3[night]);//bseat
            break;
         case 3622:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3[night]);//interior
            break;
         case 3788:
            if(pressS)
				   glMaterialfv(GL_FRONT, GL_EMISSION, red3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3[night]);//rlight
            break;
         case 3804:
            if(pressS)
   				glMaterialfv(GL_FRONT, GL_EMISSION, red3[night]);
	   		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dred3[night]);//wlight
            break;
         case 3806:
            glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3807:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3808:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//sidep
            break;
         case 3809:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 3811:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3813:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 3814:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3819:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//sidep
            break;
         case 3820:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3821:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 3830:
            if(noglass) {
               index = 3845;
               continue;
            }
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//glass
            break;
         case 3846:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3892:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//sidep
            break;
         case 3897:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 3898:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3903:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//trunk
            break;
         case 3918:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 3937:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//orn
            break;
         case 3939:
            index = 5474;   
            continue;
            break;
         case 5475:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5478:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 5479:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5480:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5484:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5487:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5498:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5501:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5509:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5511:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5514:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5515:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5516:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5517:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5518:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5519:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 5522:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5525:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 5526:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5527:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5531:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5534:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5545:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5548:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5556:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5558:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5561:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5562:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5563:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5564:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//doors
            break;
         case 5565:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, lred3[night]);//trim
            break;
         case 5566:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dgrey3[night]);//bottom
            break;
         case 5569:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, yellow3[night]);//alight
            break;
         case 5697:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3[night]);//interior
            break;
         case 5700:
            if(noglass) {
               index = 5703;
               continue;
            }
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//glass
            break;
         case 5704:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, tan3[night]);//interior
            break;
         case 5712:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5713:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5714:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5715:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5716:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5717:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5718:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5720:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5722:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5723:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5724:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5725:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5726:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5728:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5729:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5730:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5731:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5733:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5734:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5735:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5737:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5738:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5740:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5741:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5742:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5743:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, one3[night]);//embwhite
            break;
         case 5744:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//embred
            break;
         case 5745:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, blue3[night]);//embblue
            break;
         case 5746:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dark3[night]);//rubber
            break;
         case 5906:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);//blacko
            break;
         case 6386:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, grey3[night]);//grill
            break;
         case 7917:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, red3[night]);//body
            break;
         case 8565:
            glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, silver3[night]);//blue
            break;
         case 12001:
            index = (int)polyLength + 5;
            continue;
            break;
         //
      }
      glBegin(GL_POLYGON);
      for(coorI = 1; coorI <= polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         glNormal3f(coorn[point][0], coorn[point][1], coorn[point][2]);
         glVertex3f(coora[point][0], coora[point][1], coora[point][2]);
      }
      glEnd();
   }
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SHININESS, zeroS);
}

void drawWholeCar(float coorn[20000][3], float coora[20000][3], float polya[20000][200], int night, 
                  float polyLength, int hlight, int pressS, int noglass, float box[4][4][4][3], int usebox) {
   drawCar(coorn, coora, polya, night, polyLength, hlight, pressS, noglass, box, usebox);
   drawSteer(coorn, coora, polya, night, polyLength, box, usebox);
   drawRightTire(coorn, coora, polya, night, polyLength, box, usebox);
   drawLeftTire(coorn, coora, polya, night, polyLength, box, usebox);
   drawRearTires(coorn, coora, polya, night, polyLength, box, usebox);
}
