/* Holden Ridge
 * hridge
 *
 */



#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <GL/gl.h>
//#include <Winbase.h>
//#include <windows.h>
//#include <time.h>
#include <stdio.h>
#include <fstream>
#include <iostream>
#include <sstream>


#include "drawcar.h"
//#include "colors.h"
#include "imageloader.h"

//Affects the car's speed
#define XWIN 1.0f

//resolution of the water heightmap
#define WATERD 60

//Ripples are generated every RSPEED frames
#define RSPEED 3

//Ripples are animated every SSPEED frames
#define SSPEED 3

//The dimensions of the original box of controll points
//for ffd, probably not to be messed with
#define XMIN -9.5 
#define XMAX 9.5
#define YMIN -2.9
#define YMAX 2.0
#define ZMIN -3.3
#define ZMAX 3.3

//maximum number of spray projectiles
#define PROJN 150

// sleep arguement for car without free form deformations
#define LONGSLEEP 32

// sleep arguement for car with free form deformations
#define SHORTSLEEP 8

// Comment out all but oneone
// timing functions
#define XSLEEP usleep(8000); //unix 
//#define XSLEEP Sleep(sleeptime); //other
//#define XSLEEP ; //neither works, probably will result in odd performance
using namespace std;

//color defined in drawcar.cpp
extern float zero3[2][4];
extern float blue3[2][4];
extern float one3[2][4];
extern float green3[2][4];
extern float transp[2][4];
extern float transp2[2][4];
extern float half3[2][4];
extern float red3[2][4];
extern float grey3[2][4];
extern float spray[2][4];

//the depth of the car the last time the code checked if it should
//start a ripple
float lastdepth = 0.0f;

//timing functions arguement
int sleeptime = LONGSLEEP;

//stores information about water spray projectiles
//peojectile[][0] = vx
//projectile[][1] = vy;
//projectile[][2] = vz;
//projectile[][3] = in use;
//projectile[][4] = x
//projectile[][5] = y
//projectile[][6] = z
float projectile[PROJN][7];

//x,z position of each of the car's 4 tires.
float position[4][2];

// used to time how often ripples are started.
int timing = 0;

//used to time how often ripples are propagated
int splasht = 0;

//controll points for free form deformation
float box[4][4][4][3];

//added to each corner of gl texture coordinate, so that the surface
//of the water apears to move
float var = 0.0;

// toggles displaying the car's up vector, the vector the car  was 
// rotated about and the x and z axis.
int rVector = 0;

// multiplied by the height each coordinate in the heightmap of the
// land.
float hModifier = 1.0;

// used to count for how many frames the car has 
int timet;

//toggles the headlights of the car
int hlight = 0;

//toggles free form deformation
int sillyCar = 0;

// holds the color of each coordinate of the land, is updated whenever
// hmodifier or waterLevel are changed
float landColor[60][60][4];

//angle the car must be rotated to rest on the surface of the land
float thetsAngle;

// change in height from the middle of the car, to a point directly in
// between the two front tires 
float hchange;

//height of each tire once it's been rotated.
//tire[0] = left front
//trie[1] = right front
//tire[2] = left back
//tire[3] = right back  
float tire[4];

GLuint _skybox[9]; //holds faces of skybox
GLuint _texID; //id of texture

// the up vector of the car once it's been placed on land
float carup[3];

//current average value for the heightmap of the water
float waterLevel = 5.0;

// flag for each coordiante
// 1 draw water at that coordinate
// 0 don't
int waterRender[WATERD][WATERD];
// height at each coordinate
// we need 3 heightmaps at any one time
// so this is indexed into with currw, lastw, and oldw
float waterSurface[3][WATERD][WATERD];
int currw = 0, lastw = 1, oldw = 2;

//the x,z vector from the center of the car to the forward tires
float forward[2] = {-1.0, 0.0};

// x, z vector from the center of the car to the right tires
float side[2] = {0.0, -1.0};

//notmsl for each coordinate in the land heightmap 
float landn[100][100][3];

//polygon normals for each vertex
//landp[][][0][] is the upper triangle in a square
//landp[][][1][] is the lower tirangel in a square
float landp[100][100][2][3];

// toggles drawing the coordinate axis for each moving part of the car
// only works when free form deformation is off
int partAxis = 0;

// flat to keep track of if the car has gone off the edge of the land
int onSurface = 1;

// current speed of the car
float speed = 0.0;

// angle, how much the wheels/steering wheel are turned
float turn = 0.0;

// current rotational angle of the wheels(from the car moving
// forwards or backwards)
float wheelSpin = 0.0;

// toggles drawing the non-moving parts of the car
int drawChassis = 1;

//toggles drawing the land normals
int drawNormal = 0;

// toggles moving the camera to a drivers view position.
// not steady on uneven terrain.  To be improved someday.
int driverview = 0;

// toggles drawing the glass of the car, it's not transparent
int noglass = 1;

// toggles night and day time
int night = 0;

// camera position relative to the car.
float cameraUp = 120.0;
float cameraDegree = 0.0;
float cameraDistance = -90.0;

// car's up vector the last time it was on the ground,
// if the car hasn't gone off of an edge, this is probably it's current
// up vector
float lastOnGround[3] = {0.0f, 1.0f, 0.0f};

// lighting, when there's an 'n' on the end of the identifier
// it's the lighting at night

//diffuse yellow light
GLfloat light_diffuse[] = {1.0, 1.0, 1.0};
GLfloat light_diffusen[] = {0.00, 0.00, 0.00};
//dim specular light
GLfloat light_specular[] = {0.3, 0.3, 0.3};
GLfloat light_specularn[] = {0.0, 0.0, 0.0};
//really dim abmient light
GLfloat light_ambient[] = {0.4, 0.4, 0.4};
GLfloat light_ambientn[] = {0.00, 0.00, 0.00};
//light is located in the positive y direction
GLfloat light_position[] = {0.0, 1.0, 0.0, 0.0}; 

//headlight position, direction and color
GLfloat hpos[] = {0.0, 300.0, 0.0, 1.0}; 
GLfloat hdif[] = {0.95, 0.95, 0.3};
GLfloat hdir[] = {0.0, -1.0, 0.0};

GLfloat hpos2[] = {0.0, 300.0, 0.0, 1.0}; 

//tail light position, direction and color
GLfloat spos[] = {0.0, 300.0, 0.0, 1.0}; 
GLfloat sdif[] = {0.8, 0.3, 0.3};
GLfloat sdir[] = {0.0, -1.0, 0.0};

GLfloat spos2[] = {0.0, 300.0, 0.0, 1.0}; 



// the number of coordinates 
int coorLength;


//keeps track of if gourard shading is on
int gshade = 0;

// draw normal vectors for each vertex?
int normals = 0;

// allows you to scale the ship manually
float scaler = 0.5;

// chooses object coordinates or world coordinates
// 0 is world coordinates


// allows you to rotate the ship manually
float rotateX = 0.0, rotateY = 0.0, rotateZ = 0.0;
float rotateC = 0.0;

// toggles displaying the world axis
int worldAxis = 1;

//holds the window size
int hight = 500, width = 500;

// the right left or middle button is held down
int rightC = 0, leftC = 0, middleC = 0;

// flag for if 'x' 'y', or 'z' were held down when
// a mouse button was clicked
int clickM = 0, clickH = 0, clickV = 0;

// position of the mouse updated as it moves if a mouse button
// is held down
float xMouse, yMouse;

// flag for if 'x', 'y', or 'z' is held down
int pressW = 0, pressA = 0, pressS = 0, pressD = 0, pressX = 0,
pressM = 0, pressV = 0, pressH = 0;

// the distance to translate
float trans[3];
float lastrans[3] = {0.0, 0.0, 0.0};
// used to find the maximum dimension of the ship to scale it
// 100 long
float xmax = 0.0, xmin = 0.0, ymax = 0.0;
float ymin = 0.0,  zmax =0.0, zmin = 0.0;
float xdif, ydif, zdif, big, scale;

float maxx = -50.0, maxy = -50.0, maxz = -50.0;
float minx = 50.0, miny = 50.0, minz = 50.0;

// crossProduct() returns the x, y, and z values of the cross 
// product though these globals
float crossx, crossy, crossz;

//camera position in space
float cameraP[3] = {40.0, 5.0, 0.0} ;

float carP[3] = {0.0, 0.0, 0.0};
float carLook[3] = {-1.0, 0.0, 0.0};

//unit vector for the direction the camera looks in
float look[3] = {-1.0, 0.0, 0.0};

//unit vector for the up direction of the camera
float up[3] = {0.0, 1.0, 0.0};
             

// holds the contents of the coord and poly file
float coora[20000][3];
float polya[20000][200];

// holds the free form deformation coordinates
float ffd[20000][3];
float ffdn[20000][3]; // and vertex normals
float ffdpn[20000][3];// and polygon normals


// holds the normal vector for each polygon and vertex
float coorn[20000][3];
float polyn[20000][3];

// the length of the polyfile
int polyLength;

//Represents a terrain, by storing a set of heights and normals at 2D locations
class Terrain {
	private:
		int w; //Width
		int l; //Length
		float** hs; //Heights
	public:
		Terrain(int w2, int l2) {
			w = w2;
			l = l2;
			
			hs = new float*[l];
			for(int i = 0; i < l; i++) {
				hs[i] = new float[w];
			}		
		}
		~Terrain() {
			for(int i = 0; i < l; i++) {
				delete[] hs[i];
			}
			delete[] hs;
		}
		int width() {
			return w;
		}
		int length() {
			return l;
		}
		//Sets the height at (x, z) to y
		void setHeight(int x, int z, float y) {
			hs[z][x] = y;
			//computedNormals = false;
		}
		//Returns the height at (x, z)
		float getHeight(int x, int z) {
		   if(hModifier > .99)
   			return hs[z][x] * hModifier;
         else
            return 0.0f;
		}
};	


Terrain* ground;

Terrain* loadTerrain(const char* filename, float height) {
   
	Image* image = loadBMP(filename);
	Terrain* t = new Terrain(image->width, image->height);
	for(int y = 0; y < image->height; y++) {
		for(int x = 0; x < image->width; x++) {
			unsigned char color =
				(unsigned char)image->pixels[3 * (y * image->width + x)];
			float h = height * ((color / 255.0f) - 0.5f);
			t->setHeight(x, y, h);
		}
	}
	delete image;
	//t->computeNormals();
	return t;
}

void cleanup() {
	delete ground;
}

//loads the skybox textures.
GLuint loadTexture(Image *image){
	GLuint texID;
	glGenTextures(1, &texID);  //make room for texture
	//tells opengl which texture to edit
	glBindTexture(GL_TEXTURE_2D, texID);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, image->width,
		         image->height, 0, GL_RGB, GL_UNSIGNED_BYTE,
				 image->pixels);
	return texID;
}

//calculates the color of each coordinate of the land
void setLandColor(void) {
   for(int z = 0; z < ground->length(); z++) {
		for(int x = 0; x < ground->width(); x++) {
         float num = ground->getHeight(x, z);
         landColor[x][z][3] = 1.0;
         if(hModifier < .9) {
            if(waterRender[x*(WATERD)/60][z*(WATERD)/60] == 0) {
		         landColor[x][z][0] = 0.6 * (num - waterLevel/(10.0f))/10.0;
		         landColor[x][z][2] = 0.6 * (num - waterLevel/(10.0f))/10.0;
		         landColor[x][z][1] = 0.6 + 0.4*(num - waterLevel/(10.0f))/10.0;
            } else {// if (num < waterLevel/(hModifier*10.0f)) {
		         landColor[x][z][0] = 0.5 + .7 *(num - waterLevel/(10.0f))/5.0;
		         landColor[x][z][1] = 0.5 + .7* (num - waterLevel/(10.0f))/5.0;
		         landColor[x][z][2] = 0.0 + .9*(num - waterLevel/(10.0f))/5.0;
		      }
         } else {
            float num = ground->getHeight(x, z)/hModifier;
            if(waterRender[x*(WATERD)/60][z*(WATERD)/60] == 0) {
		         landColor[x][z][0] = 0.6 * (num+2 - waterLevel/(hModifier*10.0f))/10.0;
		         landColor[x][z][2] = 0.6 * (num+2 - waterLevel/(hModifier*10.0f))/10.0;
		         landColor[x][z][1] = 0.6 + 0.4*(num+2 - waterLevel/(hModifier*10.0f))/10.0;
            } else {//if (num < waterLevel/(hModifier*10.0f)) {
		         landColor[x][z][0] = 0.8 + .6 *(num - waterLevel/(hModifier*10.0f))/5.0;
		         landColor[x][z][1] = 0.8 + .6* (num - waterLevel/(hModifier*10.0f))/5.0;
		         landColor[x][z][2] = 0.1 + .4*(num - waterLevel/(hModifier*10.0f))/5.0;
		      }
         }
         if(night) {
               landColor[x][z][0] *= 0.5f;
               landColor[x][z][1] *= 0.5f;
               landColor[x][z][2] *= 0.5f;
         }
         landColor[x][z][0] *= 0.5f;
         landColor[x][z][1] *= 0.5f;
         landColor[x][z][2] *= 0.5f;
      }
   }
}

// find a vertex normal for a point near px, pz
void findNormals(float px, float pz, float *pntr) {
   px /= 40.0;
   px += 30.0;
   pz /= 40.0;
   pz += 30.0;
   int x = (int)px, z = (int)pz;
   if(px < 0.0f || pz < 0.0f || px > 59.0f || pz > 59.0f){
      pntr[0] = 0.0f;
      pntr[1] = 1.0f;
      pntr[2] = 0.0f; 
   } else {
      pntr[0] = landn[x][z][0];
      pntr[1] = landn[x][z][1];
      pntr[2] = landn[x][z][2];
   }
}

// calculates the cross product of two vectors
// and stores the result in crossx, crossy, crossz
void crossProduct(float x, float y, float z, float x2, float y2,
                   float z2) {   
   crossx = y * z2 - z * y2;
   crossy = z * x2 - x * z2;
   crossz = x * y2 - y * x2; 
   float length = crossx*crossx + crossy*crossy + crossz*crossz;
   length = sqrt(length);
   crossx /= length;
   crossy /= length;
   crossz /= length;
}

//peojectile[][0] = vx
//projectile[][1] = vy;
//projectile[][2] = vz;
//projectile[][3] = in use;
//projectile[][4] = x
//projectile[][5] = y
//projectile[][6] = z

//launches a new spray projectile
void fireProj(float x, float y, float z, float vx, float vy, float vz, float speed) {
   //printf("%f, %f, %f.  %f, %f, %f.\n", x, y, z, vx, vy, vz);
   int i;
   for(i = 0; i < PROJN; i++) { 
      if(projectile[i][3] == 0) {
         projectile[i][0] = vx + 4.0*((rand()/((double)RAND_MAX + 1)) - 0.5f);
         projectile[i][1] = vy + ((rand()/((double)RAND_MAX + 1)) - 0.5f);
         projectile[i][2] = vz + 4.0*((rand()/((double)RAND_MAX + 1)) - 0.5f);
         projectile[i][3] = 1;
         projectile[i][4] = x;// + (rand()/((double)RAND_MAX + 1)) - 0.5f;
         projectile[i][5] = y;
         projectile[i][6] = z;// + (rand()/((double)RAND_MAX + 1)) - 0.5f;
         float length = sqrt(projectile[i][0]*projectile[i][0] +
                             projectile[i][1]*projectile[i][1]);
         projectile[i][0] /= length/speed;
         projectile[i][2] /= length/speed;
         break;
         
      }
   }
   if( i > PROJN)
      printf("THE HUGE MANATEE\n");
}

//renders and advances all spray projectiles
void animateProj(void) {
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, spray[night]);
   for(int i = 0; i < PROJN; i++) {
      if(projectile[i][3]) {
         glPushMatrix();
         glTranslatef(projectile[i][4],
                      projectile[i][5],
                      projectile[i][6]);
         glutSolidSphere(0.16, 12, 12);
         glPopMatrix();
        // projtime++;
        // if(projtime>0) {
            projectile[i][4] += projectile[i][0];
            projectile[i][5] += projectile[i][1];
            projectile[i][6] += projectile[i][2];
            projectile[i][1] -= .07;
          //  projtime = 0;
         //}
         
         if(projectile[i][5]*(scale*scaler) < (waterLevel -2.0f)) {
            projectile[i][3] = 0;
         }
      }
   }
   glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
}

// calculates weights for free form deformation
void weights(float s, float weight[4]) {
   int index = (int)(s * 3);
   weight[0] = 0.0f;
   weight[1] = 0.0f;
   weight[2] = 0.0f;
   weight[3] = 0.0f;
   if(s < .33) {
      index = 0;
   } else if (s < .66) {
      index = 1;
   } else {
      index = 2;
   }
   s -= index*0.33f;
   weight[index] = 1.0f - s*3.0f;
   weight[index + 1] = s*3.0f;
}

// Bezier weights
/*void weights(float s, float weight[4]) {
   weight[0] = -pow(s, 3.0f) +3*s*s - 3*s + 1;
   weight[1] = 3*pow(s, 3.0f) -6*s*s + 3*s;
   weight[2] = -3*pow(s, 3.0f) + 3*s*s;
   weight[3] = pow(s, 3.0f);

}*/

// takes px, py, pz, deforms it and stores the result in point[3]
void drawPoint(float px, float py, float pz, float point[3]) {
   float weight[3][4];
   weights((px+8.0)/18.0, weight[0]);
   weights((py+3.0)/6.0, weight[1]);
   weights((pz+4.0)/8.0, weight[2]);
   point[0] = point[1] = point[2] = 0.0;
   for(int x = 0; x < 4; x++) {
      for(int y = 0; y < 4; y++) {
         for(int z = 0; z < 4; z++) {
            point[0] += weight[0][x]*weight[1][y]*weight[2][z]*box[x][y][z][0];
            point[1] += weight[0][x]*weight[1][y]*weight[2][z]*box[x][y][z][1];
            point[2] += weight[0][x]*weight[1][y]*weight[2][z]*box[x][y][z][2];
         }
      }
   }
}

// caluclates free form deformation normals
void polyVectors2(void) {
   int index, coorI;
   for(index = 0; index < polyLength; index++ ) {
      ffdn[index][0] = ffdn[index][1] = ffdn[index][2] = 0.0;
   }
   //printf("\n\n\n");
   //find and normalizes the normal vector for each polygon
   for(index = 0; index < (int)polyLength; index++) {
      int c0 = (int)polya[index][1];
      int c1 = (int)polya[index][2];
      int c2 = (int)polya[index][3];
      float x1, y1, z1, x2, y2, z2;
      x1 = ffd[c0][0] - ffd[c1][0];
      y1 = ffd[c0][1] - ffd[c1][1];
      z1 = ffd[c0][2] - ffd[c1][2];
      x2 = ffd[c2][0] - ffd[c1][0];
      y2 = ffd[c2][1] - ffd[c1][1];
      z2 = ffd[c2][2] - ffd[c1][2];
      crossProduct(x2, y2, z2,  x1, y1, z1);
      ffdpn[index][0] = crossx;
      ffdpn[index][1] = crossy;
      ffdpn[index][2] = crossz;
   }
   
   // for every polygon, adds that polygons normal vector
   // to the normal vector of each vertex in that polygon
   for(index = 0; index < (int)polyLength; index++) {
      for(coorI = 1; coorI < polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         ffdn[point][0] += ffdpn[index][0];
         ffdn[point][1] += ffdpn[index][1];
         ffdn[point][2] += ffdpn[index][2];
      }
   }
   
   // normalizes each vertex's normal
   for(index = 1; index <= coorLength ; index++) {
      float length = sqrt(ffdn[index][0]*ffdn[index][0] +
                          ffdn[index][1]*ffdn[index][1] +
                          ffdn[index][2]*ffdn[index][2]);
      ffdn[index][0] /= length;
      ffdn[index][1] /= length;
      ffdn[index][2] /= length;
   }
}

// manually rotates the tires of the car, and then
// applies free form deformations to the coordinates
void ffdfunc(void) {
   for(int index = 0; index <= coorLength; index++) {
      if ( (index >= 4672 && index <= 5056) ||
           (index >= 14588 && index <= 15318)) {
         float x = coora[index][0] + 4.498000;
         float y = coora[index][1] + 1.739000;
         float z = coora[index][2] + 2.524804;
         float theta = atan2(y, x) + wheelSpin*0.0174532925;
         float length = sqrt(y*y+x*x);
         x = cos(theta)*length;
         y = sin(theta)*length;
         //drawPoint(x, y, z, ffd[index]);
         length = sqrt(x*x + z*z);
         theta = atan2(x, z) + turn * 250.0*0.0174532925;
         x = sin(theta)*length;
         z = cos(theta)*length;
         drawPoint(x - 4.498000, y - 1.739000, z - 2.524804, ffd[index]);
      } else if ( (index >= 5442 && index <= 5826) ||
           (index >= 13126 && index <= 13856)) {
         float x = coora[index][0] + 4.498000;
         float y = coora[index][1] + 1.739000;
         float z = coora[index][2] - 2.524804;
         float theta = atan2(y, x) + wheelSpin*0.0174532925;
         float length = sqrt(y*y+x*x);
         x = cos(theta)*length;
         y = sin(theta)*length;
         //drawPoint(x, y, z, ffd[index]);
         length = sqrt(x*x + z*z);
         theta = atan2(x, z) + turn * 250.0*0.0174532925;
         x = sin(theta)*length;
         z = cos(theta)*length;
         drawPoint(x - 4.498000, y - 1.739000, z + 2.524804, ffd[index]);
      } else if ( (index >= 5057 && index <= 5441) ||
           (index >= 13857 && index <= 14587) ||
           (index >= 5827 && index <= 6211) ||
           (index >= 15319 && index < 16049)) { 
         float x = coora[index][0] - 5.048674;
         float y = coora[index][1] + 1.739000;
         float z = coora[index][2];
         float theta = atan2(y, x) + wheelSpin*0.0174532925;
         float length = sqrt(y*y+x*x);
         x = cos(theta)*length;
         y = sin(theta)*length;
         drawPoint(x + 5.048674, y - 1.739000, z, ffd[index]);
      }else { // 5057 - 5441, 5827-6211, 13857 - 14587, 15319 - 16049   
         drawPoint(coora[index][0], coora[index][1], coora[index][2], ffd[index]);
      }
   }
   polyVectors2();
}

//finds a normal to the land at the given px, pz coordinate
void getLandN(float px, float pz, float normal[3]) {
px /= 40.0;
   px += 30.0;
   pz /= 40.0;
   pz += 30.0;
   if(px <= 0.0f || pz <= 0.0f || px >= 60.0f || pz >= 60.0f){
      normal[0] = 0.0;
      normal[1] = 1.0;
      normal[2] = 0.0;
      return;
   }
   if(px >= 59.0 || pz >= 59.0) {
      //printf("%f->%d, %f->%d\n", px, (int)px, pz, (int)pz);
      //fflush(stdout);
      normal[0] = 0.0;
      normal[1] = 1.0;
      normal[2] = 0.0;
      return;
   }
   float d1, d2, d3, d4;
   int x = (int) px;
   int z = (int) pz;
   //printf("%f->%d, %f->%d\n", px, x, pz, z);
   d1 = sqrt(pow(px - x, 2) + pow(pz - z, 2)); //closer to original
   d2 = sqrt(pow(x + 1 - px, 2) + pow(z + 1 - pz, 2));//closer to the 
                                                      // other corner
   d3 = sqrt(pow(x - px, 2) + pow(z + 1 - pz, 2));
   d4 = sqrt(pow(x + 1 - px, 2) + pow(z - pz, 2));
   if(d1 < d2) {
     normal[0] = landn[x][z][0]/d1 +
                 landn[x][z+1][0]/d3 +
                 landn[x+1][z][0]/d4;
     normal[0] /= 1/d1 + 1/d3 + 1/d4;

     normal[1] = landn[x][z][1]/d1 +
                 landn[x][z+1][1]/d3 +
                 landn[x+1][z][1]/d4;
     normal[1] /= 1/d1 + 1/d3 + 1/d4;

     normal[2] = landn[x][z][2]/d1 +
                 landn[x][z+1][2]/d3 +
                 landn[x+1][z][2]/d4;
     normal[2] /= 1/d1 + 1/d3 + 1/d4;
      //normal[0] = landp[x][z][0][0];
      //normal[1] = landp[x][z][0][1];
      //normal[2] = landp[x][z][0][2];
   }
   else {
      normal[0] = landn[x+1][z+1][0]/d2 +
                  landn[x][z+1][0]/d3 +
                  landn[x+1][z][0]/d4;
      normal[0] /= 1/d2 + 1/d3 + 1/d4;

      normal[1] = landn[x+1][z+1][1]/d2 +
                  landn[x][z+1][1]/d3 +
                  landn[x+1][z][1]/d4;
      normal[1] /= 1/d2 + 1/d3 + 1/d4;
      
      normal[2] = landn[x+1][z+1][2]/d2 +
                  landn[x][z+1][2]/d3 +
                  landn[x+1][z][2]/d4;
      normal[2] /= 1/d2 + 1/d3 + 1/d4;
      //normal[0] = landp[x][z][1][0];
      //normal[1] = landp[x][z][1][1];
      //normal[2] = landp[x][z][1][2];
   }
}

//finds the height at px, pz, not expecting numbers 0-60 (the dimensions
// of the land heightmap, but rather a coordinate in world space.
float findHeights(float px, float pz) {
   px /= 40.0;
   px += 30.0;
   pz /= 40.0;
   pz += 30.0;
   if(px <= 0.0f || pz <= 0.0f || px >= 60.0f || pz >= 60.0f){
      return -500.0f;
   }
   if(px >= 59.0 || pz >= 59.0) {
      //printf("%f->%d, %f->%d\n", px, (int)px, pz, (int)pz);
      //fflush(stdout);
      return -500.0f;
   }
   float d1, d2;
   int x = (int) px;
   int z = (int) pz;
   //printf("%f->%d, %f->%d\n", px, x, pz, z);
   d1 = sqrt(pow(px - x, 2) + pow(pz - z, 2)); //closer to original
   d2 = sqrt(pow(x + 1 - px, 2) + pow(z + 1 - pz, 2));//closer to the 
                                                      // other corner
   if(hModifier < 0.9) {
      return ground->getHeight(30, 30);
   } else if(d1 < d2) {
      float result = ground->getHeight(x, z);
      
      result += (px - (float)x)*(ground->getHeight(x+1, z) - 
                                 ground->getHeight(x,z));
      result += (pz - (float)z)*(ground->getHeight(x, z+1) - 
                                 ground->getHeight(x,z));
      //printf("\t\t%f, %f, %f, %f\n", x, z, result, ground->getHeight(4, 4));
      return result * 10.0f;
   }
   else {
      float result = ground->getHeight(x+1, z+1);
      result += ((float)(x+1) - px)*(ground->getHeight(x, z+1) - 
                                     ground->getHeight(x+1,z+1));
      result += ((float)(z+1) - pz)*(ground->getHeight(x+1, z) - 
                                     ground->getHeight(x+1,z+1));
      //printf("\t\t%f, %f, %f, %f\n", x, z, result, ground->getHeight(4, 4));
      return result * 10.0f;
      
   }
}



// Adjusts control points for free form deformation
void deformbox() {
   float upt[3];
   crossProduct(0.0f, 1.0f, 0.0f, carLook[0], 0.0, carLook[2]);
   float fore[2], sid[2];
   getLandN(xdif, ydif, upt);
   float x = upt[0];
   float z = upt[2];
   fore[0] = carLook[0];
   fore[1] = carLook[2];
   sid[0] = crossx;
   sid[1] = crossz;
   fore[0] *= sin(atan2(sqrt(1 - z*z), x))*scale*scaler;
   fore[1] *= sin(atan2(sqrt(1 - z*z), x))*scale*scaler;
   sid[0] *= sin(atan2(sqrt(1 - x*x), z))*scale*scaler;
   sid[1] *= sin(atan2(sqrt(1 - x*x), z))*scale*scaler;
   //float mid = findHeights(trans[0]/(scale*scaler), trans[2]/(scale*scaler));
   float mid = findHeights(trans[0], trans[2]);
   
   mid /= scale*scaler;
   //glPushMatrix();
   //glTranslate(trans[0]/scale*scaler, 
   //glutSolidSphere(2.0, 6, 6);
   //glPopMatrix();
   for(int x = 0; x < 4; x++) {
      for(int y = 0; y < 4; y++) {
         for(int z = 0; z < 4; z++) {
            float xd = XMAX - (XMAX - XMIN)/3.0*x;
            float ydif = 0.0 + (YMAX - YMIN)/3.0*y;
            float zd = ZMIN + (ZMAX - ZMIN)/3.0*z;
            //xd *= sin(atan2(up[1], up[0]));
            //zd *= sin(atan2(up[1], up[2]));
            float xdif = trans[0] + xd * fore[0] + zd *sid[0];
            float zdif = trans[2] + xd * fore[1] + zd *sid[1];
            
            //getLandN(xdif, ydif, upt);
            box[x][y][z][0] = xdif/(scale*scaler) - upt[0] * ydif;
            //box[x][y][z][1] = findHeights(trans[0]/(scale*scaler) + xdif, trans[2]/(scale*scaler) + zdif)/(scale*scaler) - mid;
            box[x][y][z][1] = findHeights(xdif, zdif)/(scale*scaler);// - mid;
            if(box[x][y][z][1]*scale*scaler < -499)
               box[x][y][z][1] = trans[1]/(scale*scaler);
            box[x][y][z][1] -= upt[1] * ydif;
            box[x][y][z][2] = zdif/(scale*scaler) - upt[2] * ydif;
            box[x][y][z][0] -= trans[0]/(scale*scaler);
            box[x][y][z][1] -= trans[1]/(scale*scaler);
            box[x][y][z][2] -= trans[2]/(scale*scaler);
         }
      }
   }
   /*for(int x = 0; x < 3; x++) {
      for(int y = 0; y < 3; y++) {
         for(int z = 0; z < 4; z++) {
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3[night]);
            //printf("point %f, %f, %f\n", box[x][y][z][0],
            //                             box[x][y][z][1],
            //                             box[x][y][z][2]);
            glBegin(GL_LINE_STRIP);
            glVertex3f(box[x][y][z][0],
                       box[x][y][z][1],
                       box[x][y][z][2]);
            glVertex3f(box[x+1][y][z][0],
                       box[x+1][y][z][1],
                       box[x+1][y][z][2]);
            glVertex3f(box[x+1][y+1][z][0],
                       box[x+1][y+1][z][1],
                       box[x+1][y+1][z][2]);
            glVertex3f(box[x][y+1][z][0],
                       box[x][y+1][z][1],
                       box[x][y+1][z][2]);
            glVertex3f(box[x][y][z][0],
                       box[x][y][z][1],
                       box[x][y][z][2]);

            glEnd();
           
         }
      }
   }
   for(int x = 0; x < 4; x++) {
      for(int y = 0; y < 4; y++) {
         for(int z = 0; z < 3; z++) {
            glBegin(GL_LINES);
            glVertex3f(box[x][y][z][0],
                       box[x][y][z][1],
                       box[x][y][z][2]);
            glVertex3f(box[x][y][z+1][0],
                       box[x][y][z+1][1],
                       box[x][y][z+1][2]);
            glEnd();
         }
      }
   }*/
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
}

// figures out at which points the water is under or over the land.
void calcWater(void) {
   for(int i = 0; i < WATERD; i += 1) {
      for(int j = 0; j < WATERD; j+= 1) {
         waterRender[i][j] = 0;
      }
   }
   for(int i = 0; i < WATERD; i++) {
      for(int j = 0; j < WATERD; j++) {
         //printf("%d, %d: %f %f\n", i, j, waterLevel, findHeights(i/2 - 30, j/2 - 30));
         float ti = i, tj = j;
         if (i == 0)
            ti += 0.00001f;
         if (j == 0)
            tj += 0.00001f;
         //if(i == WATERD - 1)
         //   ti -= 1.00001f;
         //if(j == WATERD - 1)
         //   tj -= 1.00001f;
         if (findHeights((ti - WATERD/2)*2400/WATERD, (tj - WATERD/2)*2400/WATERD) -.5  < waterLevel &&
                               i < WATERD - 2 &&
                               j < WATERD - 2) {
            //printf("calc %d %d -> %f\n", i, j, findHeights(i/2 - 30, j/2 - 30));
            int imin = i -1;
            int imax = i +1;
            int jmin = j-1;
            int jmax = j+1;
            if(imin < 0)
               imin = 0;
            if(imax > WATERD - 1)
               imax = WATERD - 1;
            if(jmin < 0)
               jmin = 0;
            if(jmax > WATERD - 1)
               jmax = WATERD - 1;
            for(int m = imin; m <= imax; m++) {
               for(int n = jmin; n <= jmax; n++) {
                  //printf("    set %d, %d ->%d %d\n", i, j, m, n);
                  waterRender[m][n] = 1;
               }
            }
            //waterSurface[0][i][j] = waterLevel;
            //waterSurface[1][i][j] = waterLevel;
            //waterSurface[2][i][j] = waterLevel;
            
         } 
      }  
   }
   for(int i = 0; i < WATERD; i++) {
      for(int j = 0; j < WATERD; j ++) {
            waterSurface[0][i][j] = waterLevel;
            waterSurface[1][i][j] = waterLevel;
            waterSurface[2][i][j] = waterLevel;
         
      }
   }
   //printf("scale %f*%f ->%f\n", scale, scaler, scale*scaler);
  // for(int i = 0; i < 120; i += 2) {
  //    //printf("%d: ", i); 
  //    for(int j = 0; j < 120; j+= 2) {
   //      //printf("%d   ", waterRender[i][j]);
  //    }
  //    //printf("\n");
  // }
}

//not currently in use, can be used to ensure poly and coor files
// are being properly read in
void printFiles(void) {
   int index, coorI;
   //printf("\n\npolys %d\n", (int)polyLength);
   for(index = 0; index <= (int)polyLength; index++) {
      //printf("%d: ", (int)index);
      for(coorI = 0; coorI <= polya[index][0]; coorI++) {
         //printf("%d ", (int)polya[index][coorI]);
      }
      //printf("\n");
   }
   //printf("\n\ncoords %d\n", (int)coorLength);
   for(coorI = 0; coorI < (int)coorLength; coorI++) {
      //printf("%d: %f, %f, %f\n", coorI, coora[coorI][0], coora[coorI][1], coora[coorI][2]);
   }
}



// establishes the lighting
void lighting() {
   if(!night)
      glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
   else 
      glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffusen);
   if(!night)
      glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
   else
      glLightfv(GL_LIGHT0, GL_SPECULAR, light_specularn);
   //glLightfv(GL_LIGHT0, GL_SPECULAR, zero3[night]);
   //glLightfv(GL_LIGHT0, GL_DIFFUSE, zero3[night]);
   //glLightfv(GL_LIGHT0, GL_AMBIENT, zero3[night]);
   if(!night)
      glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
   else
      glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambientn);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position); 
   glEnable(GL_LIGHT0);
   glEnable(GL_LIGHTING);
   
      hpos[0] = trans[0] + forward[0]*1.5 + side[0]*0.95f -lastOnGround[0]*8.2f;
      hpos[1] = tire[0]-lastOnGround[1]*8.2f;
      hpos[2] = trans[2] + forward[1]*1.5 + side[1]*0.95f -lastOnGround[2]*8.2f;
      hpos2[0] = trans[0] + forward[0]*1.5 - side[0]*0.95f-lastOnGround[0]*8.2f;
      hpos2[1] = tire[1]-lastOnGround[1]*8.2f;
      hpos2[2] = trans[2] + forward[1]*1.5 - side[1]*0.95f-lastOnGround[2]*8.2f;
      spos[0] = trans[0] - forward[0]*1.95 + side[0]*1.05-lastOnGround[0]*4.9f;
      spos[1] = tire[2]-lastOnGround[1]*4.9f;
      spos[2] = trans[2] - forward[1]*1.95 + side[1]*1.05-lastOnGround[2]*4.9f;
      spos2[0] = trans[0] - forward[0]*1.95 - side[0]*1.05-lastOnGround[0]*4.9f;
      spos2[1] = tire[3]-lastOnGround[1]*4.9f;
      spos2[2] = trans[2] - forward[1]*1.95 - side[1]*1.05-lastOnGround[2]*4.9f;
   crossProduct(forward[0], 0.0, forward[1], -lastOnGround[0], -lastOnGround[1], -lastOnGround[2]);
   crossProduct( -lastOnGround[0], -lastOnGround[1], -lastOnGround[2], crossx, crossy, crossz);
   hdir[0] = crossx;
   hdir[1] = crossy - .1;
   hdir[2] = crossz;
   hpos[1] += 30;
   sdir[0] = -crossx;
   sdir[1] = -crossy -.1;
   sdir[2] = -crossz;
   spos[1] += 30;
   glLightfv(GL_LIGHT1, GL_DIFFUSE, hdif);
   glLightfv(GL_LIGHT1, GL_POSITION, hpos);
   glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, hdir);
   glLightf(GL_LIGHT1, GL_SPOT_CUTOFF, 40.0);
   glLightf(GL_LIGHT1, GL_SPOT_EXPONENT, 16.0);
   if(hlight)
      glEnable(GL_LIGHT1);
   else
      glDisable(GL_LIGHT1);
   glLightfv(GL_LIGHT2, GL_DIFFUSE, hdif);
   glLightfv(GL_LIGHT2, GL_POSITION, hpos2);
   glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, hdir); 
   glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, 40.0);
   glLightf(GL_LIGHT2, GL_SPOT_EXPONENT, 16.0);
   if(hlight)
      glEnable(GL_LIGHT2);
   else
      glDisable(GL_LIGHT2);
   glLightfv(GL_LIGHT3, GL_DIFFUSE, sdif);
   glLightfv(GL_LIGHT3, GL_POSITION, spos);
   glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, sdir);
   glLightf(GL_LIGHT3, GL_SPOT_CUTOFF, 40.0);
   glLightf(GL_LIGHT3, GL_SPOT_EXPONENT, 16.0);
   if(pressS)
      glEnable(GL_LIGHT3);
   else
      glDisable(GL_LIGHT3);
   glLightfv(GL_LIGHT4, GL_DIFFUSE, sdif);
   glLightfv(GL_LIGHT4, GL_POSITION, spos2);
   glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, sdir);
   glLightf(GL_LIGHT4, GL_SPOT_CUTOFF, 40.0);
   glLightf(GL_LIGHT4, GL_SPOT_EXPONENT, 16.0);
   if(pressS)
      glEnable(GL_LIGHT4);
   else
      glDisable(GL_LIGHT4);


}


void reset(void) {
   cameraUp = 120.0; 
   cameraDegree = 0.0;
	cameraDistance = -90.0;
   trans[0] = 0.0;
   trans[2] = 0.0;
	look[0] = -1.0;
	look[1] = look[2] = 0.0;
   carLook[0] = -1.0;
	carLook[1] = 0.0;
   carLook[2] = 0.0;
   up[0] = up[2] = 0.0;
   up[1] = 1.0;
	turn = 0.0;
	speed = 0.0;
   rotateX = 0.0;
   rotateY = 0.0;
   rotateZ = 0.0;
   onSurface = 1;
}

// redraws the screen
void idle(void) {
   //printf("%f\n",findHeights(trans[0], trans[2]));
   //printf("speed, slip %f + %f = %f\n", speed, slip, speed + slip);
   //printf("%f, %f, %f\n", trans[0], trans[1], trans[2]);
   if(onSurface) {
      //if(speed > 0.008*XWIN) 
      //else if (speed < -0.008*XWIN)
         //speed += 0.008*XWIN;
      if (pressW && speed < 7.0*XWIN)
         speed += (7.0*XWIN - speed) * .4*XWIN;
      else if(pressX) {
         if(speed <= 0.0 && speed > -4.0*XWIN)
            speed -= (speed + 4.0*XWIN) * .2*XWIN;  
      }
      float slope = atan2((float)findHeights(trans[0] + carLook[0]/5.0f, 
                                  trans[2] + carLook[2]/5.0f) -
                          findHeights(trans[0] - carLook[0]/5.0f, 
                                  trans[2] - carLook[2]/5.0f),
                          (float)sqrt((float)carLook[0]*carLook[0] +
                               carLook[1]*carLook[1])*2.0f/5.0f);
      
      //printf("speed %f, slip %f, slope %f \n", speed, slip, slope);
      if(slope < 0.5 && slope > -0.5)
         slope = 0.0f;
      slope = -sin(slope);
      
      if(slope < 0 && speed >-2.0f*XWIN){
         speed -= XWIN*.3*(2.0f*XWIN + slope);
      } else if  (slope > 0 && speed < 2.0f*XWIN) {
         speed += XWIN*.3*(2.0f*XWIN - slope);
      }
      if(speed < 0.2*XWIN && speed > -0.2*XWIN)
         speed = 0.0;
         
      speed *= 0.98;
      if(speed > .04*XWIN)
         speed -= .04*XWIN;
      else if(speed < -.04*XWIN)
         speed += .04*XWIN;
      if(pressS) {
         if(speed < .3*XWIN && speed > -.3*XWIN)
            speed = 0.0;
         //if(speed > .03*XWIN)
         speed *= .96;
         if(speed > .2*XWIN)
            speed -= .2*XWIN;
         else if(speed < -.2*XWIN)
            speed += .2*XWIN;
      }
      float depth = waterLevel - findHeights(trans[0], trans[2]);
      if(depth > 0.0f) {
         if(depth > 10.0f)
            depth = 10.0f;
         speed *= (30.0f - depth)/30.0f;
      }
      trans[0] += carLook[0] * (speed);
      trans[2] += carLook[2] * (speed);
     
      wheelSpin += (speed)/(17.369729*2.0*3.14159265)*360.0;
      
      if(wheelSpin < 0.0)
         wheelSpin += 360.0;
      if(wheelSpin > 360.0)
         wheelSpin -= 360.0;
   
      if(!(pressA || pressD) && turn < .002*XWIN && turn > -.002*XWIN)
         turn = 0.0;
      if(!(pressA || pressD) && turn < -.002*XWIN)
         turn += .002*XWIN;
      else if (!(pressA || pressD) && turn > .002*XWIN)
         turn -= .002*XWIN;
      if(pressA) {
         if(turn < 0.05)
            turn += 0.003*XWIN;
      } else if(pressD) {
         if(turn > -0.05)
            turn -= 0.003*XWIN;
      }
      if(turn < -.001 || turn > .001) {
         float x = cos(0.8*turn * (speed)/6.0 + 3.14159265358979323846/2.0);
         float y = sin(0.8*turn * (speed)/6.0 + 3.14159265358979323846/2.0);
         crossProduct(carLook[0], carLook[1], carLook[2], up[0], up[1], up[2]); 
         carLook[0] = carLook[0] * y + crossx * x;
         carLook[1] = carLook[1] * y + crossy * x;
         carLook[2] = carLook[2] * y + crossz * x;
         float length = sqrt(carLook[0]*carLook[0] + carLook[1]*carLook[1] + 
                             carLook[2]*carLook[2]);
         carLook[0] /= length;
         carLook[1] /= length;
         carLook[2] /= length;
         crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
         look[0] = look[0] * y + crossx * x;
         look[1] = look[1] * y + crossy * x;
         look[2] = look[2] * y + crossz * x;
         length = sqrt(look[0]*look[0] + look[1]*look[1] +
                             look[2]*look[2]);
         look[0] /= length;
         look[1] /= length;
         look[2] /= length;
         
         rotateY = -atan2(carLook[2], carLook[0]) * 57.2957795 + 180.0;
         
      } //working
      if(waterRender[(int)trans[0]/(2400/WATERD) + WATERD/2][(int)trans[2]/(2400/WATERD) + WATERD/2] == 1) {
         splasht++;
         float dist = sqrt(pow(trans[0] - lastrans[0], 2.0f) + 
                           pow(trans[2] - lastrans[2], 2.0f));
         //printf("DIST %f\n", dist);
         lastrans[0] = trans[0];
         lastrans[2] = trans[2];
         if(splasht == SSPEED) {
            float depth = waterSurface[currw][(int)trans[0]/(2400/WATERD) + WATERD/2][(int)trans[2]/(2400/WATERD) + WATERD/2]
                           - findHeights(trans[0], trans[2]);
           float tempdepth = depth; 
           if(lastdepth > 12 && depth > 12) {
               if(lastdepth > depth)
                  depth = lastdepth;
            } else if((lastdepth >= 12 && depth < 4 ) ||
                      (depth >= 12 && lastdepth <= 4)) { 
               depth = 4;
            } else if(lastdepth < depth) {
               depth = lastdepth;
            }
            lastdepth = tempdepth;
            //printf("depth %f\n", depth);
            if(depth > -4 && depth < 4) {   //         1 * dist
               for(int i = 0; i < 4; i++) {
                  float depth2 = waterSurface[currw][(int)position[i][0]/(2400/WATERD) + WATERD/2][(int)position[i][1]/(2400/WATERD) + WATERD/2]
                                        - findHeights(position[i][0], position[i][1]);
                  if(depth2 > 0) {
                     float change = 2*dist;
                     if(change > depth2)
                           change = depth2;
                     waterSurface[currw][(int)position[i][0]/(2400/WATERD) + WATERD/2][(int)position[i][1]/(2400/WATERD) + WATERD/2] -= change;
                  }
               }
            } else if (depth >= 4 && depth < 12) { //  4 * dist
               int i = 0;
               if(speed < 0)
                  i += 2;
               float depth2 = waterSurface[currw][(int)position[i][0]/(2400/WATERD) + WATERD/2][(int)position[i][1]/(2400/WATERD) + WATERD/2] - 
                                 findHeights(position[i][0], position[i][1]);
               float change = 4*dist;
               if(change > depth)
                  change = depth;
               waterSurface[currw][(int)position[i][0]/(2400/WATERD) + WATERD/2][(int)position[i][1]/(2400/WATERD) + WATERD/2] -= change;
               depth2 = waterSurface[currw][(int)position[i+1][0]/(2400/WATERD) + WATERD/2][(int)position[i+1][1]/(2400/WATERD) + WATERD/2] - 
                                 findHeights(position[i+1][0], position[i+1][1]);
               change = 8*dist;
               //if(change > depth)
               //   change = depth;
               waterSurface[currw][(int)position[i+1][0]/(2400/WATERD) + WATERD/2][(int)position[i+1][1]/(2400/WATERD) + WATERD/2] += change;
               printf("change %f\n", change);

               if(change > 1 || change < -1){
                  for(int index = 0; index < 12; index++) {
                     if(speed >0)
                        fireProj(trans[0]/(scale*scaler), (waterLevel+.01)/(scale*scaler), trans[2]/(scale*scaler), 
                                 forward[0], 0.8f, forward[1], 2.0f);
                     else
                        fireProj(trans[0]/(scale*scaler), (waterLevel+.01)/(scale*scaler), trans[2]/(scale*scaler), 
                                 -forward[0], 0.8f*dist/10.f, -forward[1], dist/10.0f);
                  }
               }
            } else if (depth < 30) {     //        48/12*dist
               int i = 0;
               if(speed < 0)
                  i += 2;
               waterSurface[currw][(int)position[i][0]/(2400/WATERD) + WATERD/2][(int)position[i][1]/(2400/WATERD) + WATERD/2] += 72*dist/depth;
               waterSurface[currw][(int)position[i+1][0]/(2400/WATERD) + WATERD/2][(int)position[i+1][1]/(2400/WATERD) + WATERD/2] += 72*dist/depth;
            }
         
         splasht = 0;
         }
      }
   } else {
      if(timet > 150) {
         onSurface = 1;
         reset();
      }
      crossProduct(lastOnGround[0], lastOnGround[1], lastOnGround[2],
                   carLook[0], carLook[1], carLook[2]);
      
      timet++;
      if(speed > 0) {
         if(carLook[1] >-.99) {
            carLook[1] -= .01;
            float lens = sqrt(carLook[0]*carLook[0] + carLook[1]*carLook[1] +
                             carLook[2]*carLook[2]);
            carLook[0] /= lens;
            carLook[1] /= lens;
            carLook[2] /= lens;   
         }
         if(speed < 10.0f) {
            speed += (10.f - speed)*0.008f*XWIN*(-carLook[1]);
         }
      } else {
         if(carLook[1] < .99) {
            carLook[1] += .01;
            float lens = sqrt(carLook[0]*carLook[0] + carLook[1]*carLook[1] +
                             carLook[2]*carLook[2]);
            carLook[0] /= lens;
            carLook[1] /= lens;
            carLook[2] /= lens;   
            
         }
         if(speed > -10.0f) {
            speed -= (10.f - speed)*0.008f*XWIN*(-carLook[1]);
         }
      }
      
      trans[0] +=carLook[0]*(speed);
      trans[1] +=carLook[1]*(speed);
      trans[2] +=carLook[2]*(speed);
      crossProduct(carLook[0], carLook[1], carLook[2],
                   crossx, crossy, crossz);
      lastOnGround[0] = crossx;   
      lastOnGround[1] = crossy;
      lastOnGround[2] = crossz;
   }
   
   glutPostRedisplay();
   XSLEEP
}





// Calculates all the normal vectors
void polyVectors(void) {
   int index, coorI;
   for(index = 0; index < polyLength; index++ ) {
      coorn[index][0] = coorn[index][1] = coorn[index][2] = 0.0;
   }
   //printf("\n\n\n");
   //find and normalizes the normal vector for each polygon
   for(index = 0; index < (int)polyLength; index++) {
      int c0 = (int)polya[index][1];
      int c1 = (int)polya[index][2];
      int c2 = (int)polya[index][3];
      float x1, y1, z1, x2, y2, z2;
      x1 = coora[c0][0] - coora[c1][0];
      y1 = coora[c0][1] - coora[c1][1];
      z1 = coora[c0][2] - coora[c1][2];
      x2 = coora[c2][0] - coora[c1][0];
      y2 = coora[c2][1] - coora[c1][1];
      z2 = coora[c2][2] - coora[c1][2];
      crossProduct(x2, y2, z2,  x1, y1, z1);
      polyn[index][0] = crossx;
      polyn[index][1] = crossy;
      polyn[index][2] = crossz;
   }
   
   // for every polygon, adds that polygons normal vector
   // to the normal vector of each vertex in that polygon
   for(index = 0; index < (int)polyLength; index++) {
      for(coorI = 1; coorI < polya[index][0]; coorI++) {
         int point = (int)polya[index][coorI];
         coorn[point][0] += polyn[index][0];
         coorn[point][1] += polyn[index][1];
         coorn[point][2] += polyn[index][2];
      }
   }
   
   // normalizes each vertex's normal
   for(index = 1; index <= coorLength ; index++) {
      float length = sqrt(coorn[index][0]*coorn[index][0] +
                          coorn[index][1]*coorn[index][1] +
                          coorn[index][2]*coorn[index][2]);
      coorn[index][0] /= length;
      coorn[index][1] /= length;
      coorn[index][2] /= length;
   }
}

void waterNormal(float wnormal[3], int x, int y) {
   wnormal[0] = 0.0;
   wnormal[1] = 0.0;
   wnormal[2] = 0.0;
   if(x > 0) {
      float ydif = -waterSurface[currw][x-1][y] + waterSurface[currw][x][y];
      float xdif = 2400/WATERD;
      float length = sqrt(ydif*ydif + xdif*xdif);
      wnormal[0] += ydif*2.0f/length;
      wnormal[1] += xdif/length;
   }
   if(x + 1 < WATERD) {
      float ydif = -waterSurface[currw][x][y] + waterSurface[currw][x+1][y];
      float xdif = 2400/WATERD;
      float length = sqrt(ydif*ydif + xdif*xdif);
      wnormal[0] += ydif*2.0f/length;
      wnormal[1] += xdif/length;
   }
   if(y > 0) {
      float ydif = -waterSurface[currw][x][y-1] + waterSurface[currw][x][y];
      float xdif = 2400/WATERD;
      float length = sqrt(ydif*ydif + xdif*xdif);
      wnormal[2] += ydif*2.0f/length;
      wnormal[1] += xdif/length;
   }
   if(y + 1 < WATERD) {
      float ydif = -waterSurface[currw][x][y] + waterSurface[currw][x][y+1];
      float xdif = 2400/WATERD;
      float length = sqrt(ydif*ydif + xdif*xdif);
      wnormal[2] += ydif*2.0f/length;
      wnormal[1] += xdif/length;
   }
   float length = sqrt(wnormal[0]*wnormal[0] + wnormal[1]*wnormal[1] +
                       wnormal[2]*wnormal[2]);
   wnormal[0] /= length;
   wnormal[1] /= length;
   wnormal[2] /= length;

}

// Calculates all the normal vectors
void landVectors(void) {
   int z, x;
   for(z = 0; z < ground->length(); z++) {
		for(x = 0; x < ground->width(); x++) {
         landn[x][z][0] = landn[x][z][1] = landn[x][z][2] = 0.0;
      }
   }

   //find and normalizes the normal vector for each polygon
   for(z = 0; z < ground->length() - 1; z++) {
		float x1, y1, z1, x2, y2, z2;
      for(x = 0; x < ground->width() - 1; x++) {
         x1 = 0.0;
         y1 = ground->getHeight(x, z+1)*5 - ground->getHeight(x, z)*5;
         z1 = 40.0;
         x2 = 40.0;
         y2 = ground->getHeight(x+1, z)*5 - ground->getHeight(x, z)*5;
         z2 = 0.0;
         crossProduct(x2, y2, z2,  x1, y1, z1);
         landp[x][z][0][0] = crossx;
         landp[x][z][0][1] = crossy;
         landp[x][z][0][2] = crossz;
         
         x1 = 0.0;
         y1 = ground->getHeight(x+1, z)*10 - ground->getHeight(x+1, z+1)*10;
         z1 = -40.0;
         x2 = -40.0;
         y2 = ground->getHeight(x, z+1)*10 - ground->getHeight(x+1, z+1)*10;
         z2 = 0.0;
         crossProduct(x2, y2, z2,  x1, y1, z1);
         landp[x][z][1][0] = crossx;
         landp[x][z][1][1] = crossy;
         landp[x][z][1][2] = crossz;
      }
   }
   // for every polygon, adds that polygons normal vector
   // to the normal vector of each vertex in that polygon
   for(z = 0; z < ground->length() - 1; z++) {
      for(x = 0; x < ground->width() - 1; x++) {
         landn[x][z][0] += landp[x][z][0][0]; 
         landn[x][z][1] += landp[x][z][0][1];
         landn[x][z][2] += landp[x][z][0][2];
         landn[x + 1][z][0] += landp[x][z][0][0]; 
         landn[x + 1][z][1] += landp[x][z][0][1];
         landn[x + 1][z][2] += landp[x][z][0][2];
         landn[x][z + 1][0] += landp[x][z][0][0]; 
         landn[x][z + 1][1] += landp[x][z][0][1];
         landn[x][z + 1][2] += landp[x][z][0][2];
         landn[x + 1][z + 1][0] += landp[x][z][1][0]; 
         landn[x + 1][z + 1][1] += landp[x][z][1][1];
         landn[x + 1][z + 1][2] += landp[x][z][1][2];
         landn[x + 1][z][0] += landp[x][z][1][0]; 
         landn[x + 1][z][1] += landp[x][z][1][1];
         landn[x + 1][z][2] += landp[x][z][1][2];
         landn[x][z + 1][0] += landp[x][z][1][0]; 
         landn[x][z + 1][1] += landp[x][z][1][1];
         landn[x][z + 1][2] += landp[x][z][1][2];
      }
   }
   
   // normalizes each vertex's normal
   for(z = 0; z < ground->length(); z++) {
		for(x = 0; x < ground->width(); x++) {
         float length = sqrt(landn[x][z][0]*landn[x][z][0] +
                             landn[x][z][1]*landn[x][z][1] +
                             landn[x][z][2]*landn[x][z][2]);
         landn[x][z][0] /= length;
         landn[x][z][1] /= length;
         landn[x][z][2] /= length;
         
      }
   }
}

void drawWater(void) {
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   
   var += .01;
   if(var >= 1)
       var -= 1;
   //printf("water level %f\n", waterLevel);
   glEnable(GL_BLEND);
   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   
   //glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, water4[night]);
   int drawing = 0;   
   timing++;
   if(timing == RSPEED) {
      currw--;
      if(currw < 0)
         currw = 2;
      lastw--;
      if(lastw < 0)
         lastw = 2;
      oldw--;
      if(oldw < 0)
         oldw = 2;
      for(int i = 0; i <= WATERD - 1; i++) {
         for(int j = 0; j <= WATERD - 1; j++) {
            int jm = j - 1;
            int im = i - 1;
            if(j == 0)
               jm = 119;
            if(i == 0)
               im = 119;
            if(waterRender[i][j]){ //|| waterRender[i-1][j]) {
               waterSurface[currw][i][j] = 0.0;
               float div = 0.0;
               if (waterRender[im][j] == 1) {
                  waterSurface[currw][i][j] += waterSurface[lastw][im][j]/2.0;
                  div += .25;
               }
               if (waterRender[i+1][j] == 1) {
                  waterSurface[currw][i][j] += waterSurface[lastw][i+1][j]/2.0;
                  div += .25;
               }
               if (waterRender[i][jm] == 1) {
                  waterSurface[currw][i][j] += waterSurface[lastw][i][jm]/2.0;
                  div += .25;
               }
               if (waterRender[i][j+1] == 1) {
                  waterSurface[currw][i][j] += waterSurface[lastw][i][j+1]/2.0;
                  div += .25;
               }
               if(div < .01)
                  waterSurface[currw][i][j] = waterSurface[lastw][i][j];
               else {
                  
                  waterSurface[currw][i][j] -= waterSurface[oldw][i][j]*div*div;
                  waterSurface[currw][i][j] *= 1 / (div*2 - div*div);
                  //waterSurface[lastw][i][j] = waterSurface[lastw][i][j] + waterSurface[currw][i][j];
                  //waterSurface[lastw][i][j] /=2.0f;
               }
               waterSurface[currw][i][j] -= (waterSurface[currw][i][j] -
                                             waterLevel) /32;
               if (waterSurface[currw][i][j]  - waterLevel < .01)// &&
                   //(-waterSurface[currw][i][j])  +waterLevel < .01)
                 waterSurface[currw][i][j] = waterLevel; 
            
            } else {
            waterSurface[currw][i][j] = waterSurface[lastw][i][j] -
                                       (waterSurface[lastw][i][j] -
                                         waterLevel);
            }
         }
         
      }
      timing = 0;
   }
   for(int i = 0; i < WATERD-1; i++) {
      for(int j = 0; j < WATERD-1; j++) {
         float wsurface = waterSurface[currw][i][j];
         float land = findHeights((i - WATERD/2)*2400/WATERD, (j - WATERD/2)*2400/WATERD);
         if(land  < waterLevel && wsurface < land)
            waterSurface[currw][i][j] = land + .01;
         else if (land > waterLevel && wsurface > land)
            waterSurface[currw][i][j] = land - .01;
            
      }
   }
   //glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, transp[night]);
   glEnable(GL_TEXTURE_2D);
   glBindTexture(GL_TEXTURE_2D, _skybox[7]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
   

   for(int i = 0; i < WATERD-1; i++) {
      
      for(int j = 0; j < WATERD-1; j++) {
         //printf("%d, %d: %d\n", i, j, waterRender[i][j]);
         if(waterRender[i][j] == 1) {
            if(drawing == 0) {
               glBegin(GL_TRIANGLES);
               drawing = 1;
            }
            float norm[3];
            waterNormal(norm, i, j);
            glNormal3f(norm[0], norm[1], norm[2]);
            glTexCoord2f(0.0f + var, 0.0f + var);
            glVertex3f((i-WATERD/2)*2400/WATERD, waterSurface[currw][i][j], (j-WATERD/2)*2400/WATERD);
            
            float norm2[3];
            waterNormal(norm2, i + 1, j);
            glNormal3f(norm2[0], norm2[1], norm2[2]);
            glTexCoord2f(1.0f + var, 0.0f + var);
            glVertex3f((i-WATERD/2+1)*2400/WATERD, waterSurface[currw][i+1][j], (j-WATERD/2)*2400/WATERD);
            
            float norm3[3];
            waterNormal(norm3, i, j + 1);
            glNormal3f(norm3[0], norm3[1], norm3[2]);
            glTexCoord2f(0.0f + var, 1.0f + var);
            glVertex3f((i-WATERD/2)*2400/WATERD, waterSurface[currw][i][j+1], (j-WATERD/2 + 1)*2400/WATERD);
            
            glNormal3f(norm2[0], norm2[1], norm2[2]);
            glTexCoord2f(1.0f + var, 0.0f + var);
            glVertex3f((i-WATERD/2+1)*2400/WATERD, waterSurface[currw][i+1][j], (j-WATERD/2)*2400/WATERD);
            
            glNormal3f(norm3[0], norm3[1], norm3[2]);
            glTexCoord2f(0.0f + var, 1.0f + var);
            glVertex3f((i-WATERD/2)*2400/WATERD, waterSurface[currw][i][j+1], (j-WATERD/2+1)*2400/WATERD);
            

            waterNormal(norm, i+1, j+1);
            glNormal3f(norm[0], norm[1], norm[2]);
            glTexCoord2f(1.0f + var, 1.0f + var);
            glVertex3f((i-WATERD/2+1)*2400/WATERD, waterSurface[currw][i+1][j+1], (j-WATERD/2+1)*2400/WATERD);
            

         } else {
            if (drawing == 1) {
               glEnd();
               drawing = 0;
            }
         }  
      }
      if(drawing == 1) {
         glEnd();
         drawing = 0;
      }
   }
   //glDisable(GL_BLEND);
   glDisable(GL_TEXTURE_2D);
   
   glMaterialfv(GL_FRONT, GL_EMISSION, blue3[night]);
   glLineWidth(1.0);
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   
   /*for(int i = 0; i < WATERD - 2; i++) {
      
      for(int j = 0; j <= WATERD - 2; j++) {
         //printf("%d, %d: %d\n", i, j, waterRender[i][j]);
         if(true) {
            if(drawing == 0) {
               glBegin(GL_TRIANGLE_STRIP);
               drawing = 1;
            }
            //float norm[3];
            //waterNormal(norm, i, j);
            glNormal3f(0.0, 1.0, 0.0);
            glVertex3f((i-WATERD/2)*2400/WATERD, waterSurface[currw][i][j] + .1, (j-WATERD/2)*2400/WATERD);
            
            //waterNormal(norm, i, j);
            glNormal3f(0.0, 1.0, 0.0);
            glVertex3f((i-WATERD/2+1)*2400/WATERD, waterSurface[currw][i + 1][j] + .1, (j-WATERD/2)*2400/WATERD);
            
         } else {
            if (drawing == 1) {
               glEnd();
               drawing = 0;
            }
         }  
      }
      if(drawing == 1) {
         glEnd();
         drawing = 0;
      }
   }
   */
   glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
   glLineWidth(1.0);
   
   glMaterialfv(GL_FRONT, GL_EMISSION, one3[night]);
   /*glBegin(GL_LINES);
   for(int i = 0; i < WATERD - 2; i++) {
      
      for(int j = 0; j <= WATERD - 2; j++) {
         
         float norm[3];
         waterNormal(norm, i, j);
         glVertex3f((i-WATERD/2)*2400/WATERD, waterSurface[currw][i][j], (j-WATERD/2)*2400/WATERD);
         glVertex3f((i-WATERD/2)*2400/WATERD + norm[0]*5, 
                    waterSurface[currw][i][j] + norm[1]*5, 
                    (j-WATERD/2)*2400/WATERD + norm[2]*5);  
      }
   }
   glEnd();
   */glMaterialfv(GL_FRONT, GL_EMISSION, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   
}

void drawLand(void) {
   //glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
   
   //printf("%d\n", ground->width());
   // glTranslatef(0.0f, -10.0f, 0.0f);
	glTranslatef(-(float)(ground->width()) * 40 / 2,
				 0.0f,
				 -(float)(ground->length()) * 40 / 2);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]); 
   glMaterialfv(GL_FRONT, GL_SPECULAR, half3[night]);
	float temp[4] = {0.0, 0.6, 0.0, 1.0};
	//printf("%d, %d\n", ground->length(), ground->width());
	for(int z = 0; z < ground->length()-1; z++) {
		glBegin(GL_TRIANGLES);
		for(int x = 0; x < ground->width()-1; x++) {
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, landColor[x][z]);
			glNormal3f(-landn[x][z][0], -landn[x][z][1], -landn[x][z][2]);
			glVertex3f(x*40, ground->getHeight(x, z)*10, z*40);
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, landColor[x][z+1]);
			glNormal3f(-landn[x][z+1][0], -landn[x][z+1][1], -landn[x][z+1][2]);
			glVertex3f(x*40, ground->getHeight(x, z + 1)*10, (z + 1)*40);
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, landColor[x+1][z]);
			glNormal3f(-landn[x+1][z][0], -landn[x+1][z][1], -landn[x+1][z][2]);
			glVertex3f((x+1)*40, ground->getHeight(x+1, z)*10, (z)*40);
         
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, landColor[x+1][z+1]);
			glNormal3f(-landn[x+1][z+1][0], -landn[x+1][z+1][1], -landn[x+1][z+1][2]);
			glVertex3f((x+1)*40, ground->getHeight(x+1, z+1)*10, (z+1)*40);
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, landColor[x][z+1]);
			glNormal3f(-landn[x][z+1][0], -landn[x][z+1][1], -landn[x][z+1][2]);
			glVertex3f(x*40, ground->getHeight(x, z + 1)*10, (z + 1)*40);
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, landColor[x+1][z]);
			glNormal3f(-landn[x+1][z][0], -landn[x+1][z][1], -landn[x+1][z][2]);
			glVertex3f((x+1)*40, ground->getHeight(x+1, z)*10, (z)*40);
		}
		glEnd();
	}
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, green3[night]);
   if(hModifier < .9) {
      for(int z = 0; z < ground->length() - 1; z++) {
		   glBegin(GL_LINES);
		   for(int x = 0; x < ground->width() - 1; x++) {
             glVertex3f(x*40+40, ground->getHeight(x, z)*10+.1, z*40);
             glVertex3f(x*40, ground->getHeight(x, z)*10+.1, z*40);
             glVertex3f(x*40, ground->getHeight(x, z)*10+.1, z*40+40);
             glVertex3f(x*40, ground->getHeight(x, z)*10+.1, z*40);
             
         }
         glEnd();
      }
   } /*else {
      for(int z = 0; z < ground->length() - 1; z++) {
		   glBegin(GL_LINES);
		   for(int x = 0; x < ground->width() - 1; x++) {
            if(waterRender[x+1][z] == 0 && waterRender[x][z] == 0) {
               glVertex3f(x*40+40, ground->getHeight(x+1, z)*10+.1, z*40);
               glVertex3f(x*40, ground->getHeight(x, z)*10+.1, z*40);
            } else if(waterRender[x][z+1] == 0 && waterRender[x][z] == 0){
               glVertex3f(x*40, ground->getHeight(x, z+1)*10+.1, z*40+40);
               glVertex3f(x*40, ground->getHeight(x, z)*10+.1, z*40);
            }  
         }
         glEnd();
      }
   }*/
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3[night]);
	temp[0] = 0.0;
	temp[1] = 0.0;
	temp[2] = 0.0;
	if(drawNormal) {
      for(int z = 0; z < ground->length(); z++) {
         glBegin(GL_LINES);
	      for(int x = 0; x < ground->width(); x++) {
	         
	         float diff = findHeights((x-30)*40, (z-30)*40) - waterLevel*hModifier;
	         //printf("%f\n", diff);
	         if(diff > 10) {
	            temp[0] = 0.0f;
	            temp[1] = 0.0f;
	            temp[2] = 0.0f;
	         } else if (diff >= 0) {
	            temp[0] = (10.0f - diff)/10.0f;
	            temp[1] = (10.0f - diff)/10.0f;
	            temp[2] = (10.0f - diff)/10.0f;
	         } else if (diff > -10) {
	            temp[0] = (10.0f + diff)/10.0f;
	            temp[1] = (10.0f + diff)/10.0f;
	            temp[2] = 1.0f;
	         }
	         else {
	            temp[0] = 0.0f;
	            temp[1] = 0.0f;
	            temp[2] = 1.0f;
	         }
		      //temp[0] = ((float)x)/ground->width();
            //temp[1] = ((float)z)/ground->length(); 
            //temp[2] = 0.5;
            glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
            glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, temp);
			   glVertex3f(x*40 - landn[x][z][0]*40, 
			              ground->getHeight(x, z)*10 - landn[x][z][1]*10, 
			              z*40 - landn[x][z][2]*40);
			   glVertex3f(x*40, ground->getHeight(x, z)*10, z*40);
		   }
		   glEnd();
		   
	   }
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT, GL_SPECULAR, zero3[night]);
   
}
   


 //  float temp[3];
 //  findNormals(trans[0], 
 //              trans[2],
 //              temp);
 //tire[0] = left front
 //trie[1] = right front
 //tire[2] = left back
 //tire[3] = right back              
void tirePlace(float temp[]) {
   float x = temp[0];
   float y = temp[1];
   float z = temp[2];
   
   crossProduct(0.0f, 1.0f, 0.0f, carLook[0], 0.0, carLook[2]);
   float back[2], tire2[4];
   forward[0] = carLook[0];
   forward[1] = carLook[2];
   side[0] = crossx;
   side[1] = crossz;
   back[0] = forward[0];
   back[1] = forward[1];
   
   forward[0] *= sin(atan2(sqrt(1 - z*z), x)) * 4.498000*scale*scaler;
   forward[1] *= sin(atan2(sqrt(1 - z*z), x))*4.498000*scale*scaler;
   back[0] *= sin(atan2(sqrt(1 - z*z), x))*5.048674*scale*scaler;
   back[1] *= sin(atan2(sqrt(1 - z*z), x))*5.048674*scale*scaler;
   side[0] *= sin(atan2(sqrt(1 - x*x), z))*2.524804*scale*scaler;
   side[1] *= sin(atan2(sqrt(1 - x*x), z))*2.524804*scale*scaler;
   tire[0] = findHeights(trans[0] + forward[0] + side[0],
                         trans[2] + forward[1] + side[1]);
   tire[1] = findHeights(trans[0] + forward[0] - side[0],
                         trans[2] + forward[1] - side[1]);
   tire[2] = findHeights(trans[0] - back[0] + side[0],
                         trans[2] - back[1] + side[1]);
   tire[3] = findHeights(trans[0] - back[0] - side[0],
                         trans[2] - back[1] - side[1]);
   //printf("\t\t%f, %f, %f, %f\n", tire[0], tire[1], tire[2], tire[3]);
   if ( tire[0] < -450.0f || tire[1] < -450.0f || tire[2] < -450.0f ||
        tire[3] < -450.0f) {
      onSurface = 0;
      timet = 0;
      temp[0] = lastOnGround[0]; 
      temp[1] = lastOnGround[1];
      temp[2] = lastOnGround[2];
      return;
   }
                                               
   tire2[0] = tire[1] + tire[2] - tire[3];
   tire2[1] = tire[0] + tire[3] - tire[2];
   tire2[2] = tire[0] + tire[3] - tire[1];
   tire2[3] = tire[1] + tire[2] - tire[0];
   
   position[0][0] = trans[0] + forward[0] + side[0];
   position[0][1] = trans[2] + forward[1] + side[1];
   position[1][0] = trans[0] + forward[0] - side[0];
   position[1][1] = trans[2] + forward[1] - side[1];
   position[2][0] = trans[0] - forward[0] + side[0];
   position[2][1] = trans[2] - forward[1] + side[1];
   position[3][0] = trans[0] - forward[0] - side[0];
   position[3][1] = trans[2] - forward[1] - side[1];
   
   if(tire[0] < tire2[0]) {
      if(tire[3] < tire2[3]) {
         tire[3] = (tire[3] + tire2[3]) /2.0f;
         tire[0] = (tire[0] + tire2[0]) /2.0f;
      } else {
         tire[0] = tire2[0];
      }
   } else if(tire[1] < tire2[1]) {
      if(tire[2] < tire2[2]) {
         tire[2] = (tire[2] + tire2[2]) /2.0f;
         tire[1] = (tire[1] + tire2[1]) /2.0f;
      } else {
         tire[1] = tire2[1];
      }
   } else if(tire[2] < tire2[2]) {
      tire[2] = tire2[2];
   } else if(tire[3] < tire2[3]) {
      tire[3] = tire2[3];
   }
   //printf("tire %f, %f, %f, %f", tire[0], tire[1], tire[2], tire[3]);
  
   float hight = tire[0]/2.0f + tire[1]/2.0f + (tire[2] - tire[0])*
                                      (4.498000/(4.498000+5.048674));
   trans[1] = hight;
   //printf(" = %f\n", hight);
   hchange = tire[0]/2.0f + tire[1]/2.0f - trans[1];
   float X, Y, Z, X1, Y1, Z1;
   X = position[1][0] - position[0][0];
   Z = position[1][1] - position[0][1];
   Y = tire[1] - tire[0];
   X1 = position[2][0] - position[0][0];
   Z1 = position[2][1] - position[0][1];
   Y1 = tire[2] - tire[0];
   if(hModifier < 0.9) {
      crossx = 0.0;
      crossy = -1.0;
      crossz = 0.0;
   }
   crossProduct(X, Y, Z, X1, Y1, Z1);
   temp[0] = crossx;
   temp[1] = crossy;
   temp[2] = crossz;
   lastOnGround[0] = crossx;
   lastOnGround[1] = crossy;
   lastOnGround[2] = crossz;
   //printf("up tire %f, %f, %f posit %f, %f, %f\n", temp[0], temp[1], temp[2], trans[0], trans[1], trans[2]);
}

void drawSky(void){

	//glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
   //glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, one3);


	//front
	glBindTexture(GL_TEXTURE_2D, _skybox[2]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(-240.0f, 240.0f, -240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, 240.0f, -240.0f);
	glEnd();

	//left
	glBindTexture(GL_TEXTURE_2D, _skybox[1]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, 240.0f, -240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, 240.0f, 240.0f);
	glEnd();

	//back
   glBindTexture(GL_TEXTURE_2D, _skybox[0]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, 240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(-240.0f, 240.0f, 240.0f);
	glEnd();

	//right
	glBindTexture(GL_TEXTURE_2D, _skybox[3]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
	glTexCoord2f(0, 0);
	glVertex3f(-240.0f, -240.0f, -240.0f);
	glTexCoord2f(1, 0);
	glVertex3f(-240.0f, -240.0f, 240.0f);
	glTexCoord2f(1, 1);
	glVertex3f(-240.0f, 240.0f, 240.0f);
	glTexCoord2f(0, 1);
   glVertex3f(-240.0f, 240.0f, -240.0f);
	glEnd();

	//top
	   glBindTexture(GL_TEXTURE_2D, _skybox[4]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, 240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, 240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, 240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, 240.0f, -240.0f);
	glEnd();

	//bottom
	   glBindTexture(GL_TEXTURE_2D, _skybox[5]);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
	               GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		           GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-240.0f, -240.0f, -240.0f);
		glTexCoord2f(1, 0);
		glVertex3f(-240.0f, -240.0f, 240.0f);
		glTexCoord2f(1, 1);
		glVertex3f(240.0f, -240.0f, 240.0f);
		glTexCoord2f(0, 1);
		glVertex3f(240.0f, -240.0f, -240.0f);
	glEnd();
}


// draws the screen and handles translations/rotations/scales
void display(void) {
   //printf("%f, %f, %f\n\t%f, %f, %f\n",carLook[0], carLook[1], carLook[2], trans[0], trans[1], trans[2]);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
   float temp[3];
   findNormals(trans[0], 
               trans[2],
               temp);
   
   
   // draw the ship
   glPushMatrix();
   glScalef(scale * scaler, scale * scaler, scale * scaler);
   if(onSurface)
      tirePlace(temp);
   else {
      temp[0] = lastOnGround[0];
      temp[1] = lastOnGround[1];
      temp[2] = lastOnGround[2];
   }
   
   glPopMatrix();
   //SKYBOX
   
   glPushMatrix();
   //if(drawGround) {
   if(!driverview) {
      crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
      float underC;
      underC = findHeights(trans[0] + 
                  cameraDistance*look[0]*cos(cameraDegree) +
                  cameraDistance*crossx*sin(cameraDegree), 
                  trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                  cameraDistance*crossz*sin(cameraDegree));
      if(onSurface && underC >  trans[1] + cameraUp) {
         cameraUp = underC - trans[1];            
      }
      
      gluLookAt(0.0, 0.0, 0.0,
              -(cameraDistance*look[0]*cos(cameraDegree) +
                        cameraDistance*crossx*sin(cameraDegree)), 
             -(8.353187 + cameraUp), 
             -(cameraDistance*look[2]*cos(cameraDegree) +  
                        cameraDistance*crossz*sin(cameraDegree)),  
            up[0], up[1], up[2]);
   } else {
      gluLookAt(0.0f, 0.0f, 0.0f,
                forward[0]*1, 
                hchange, 
                forward[1]*1,
                -lastOnGround[0], -lastOnGround[1], -lastOnGround[2]);  
   }
  
   glTranslatef(0.0, 30.0, 0.0);
   glScalef(1, 1, 1);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3[night]);
   if(!night)
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3[night]);
   else 
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, half3[night]);
   //glPushAttrib(GL_ENABLE_BIT);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);
	//glDisable(GL_LIGHTING);
	drawSky();
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	//glEnable(GL_LIGHTING);
	//glPopAttrib();
	glPopMatrix();
   //ENDSKYBOX
   glPushMatrix();
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   
   // set the camera position  
   if(!driverview) {
      
      crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
      
      gluLookAt(trans[0] + cameraDistance*look[0]*cos(cameraDegree) +
                           cameraDistance*crossx*sin(cameraDegree), 
                8.353187 + trans[1] + cameraUp, 
                trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                           cameraDistance*crossz*sin(cameraDegree), 
                trans[0], 
                trans[1], 
                trans[2],  
                up[0], up[1], up[2]);
   } else {
      float eyex = trans[0] - forward[0] * 0.25+ side[0] * 0.6;
      float eyez = trans[2] - forward[1] * 0.25+ side[1] * 0.6;
      float lookx = trans[0] + forward[0]*0.75 + side[0] * 0.6;
      float lookz = trans[2] + forward[1]*0.75 + side[1] * 0.6;
      gluLookAt(eyex  - lastOnGround[0]*12.0, 
                trans[1] - lastOnGround[1]*12.0, 
                eyez - lastOnGround[2]*12.0,
                lookx - lastOnGround[0]*12.0,
                trans[1] + hchange - lastOnGround[1]*12.0, 
                lookz - lastOnGround[2]*12.0,
                -lastOnGround[0], -lastOnGround[1], -lastOnGround[2]);      
   }
   // establish lighting 8989
   lighting();
   
   // draw the ground
   
   glPushMatrix();
   //glShadeModel(GL_FLAT);
   drawLand();
   //glShadeModel(GL_SMOOTH);
   glPopMatrix();
   
   glPushMatrix();
   // draw the ship
   
   glScalef(scale * scaler, scale * scaler, scale * scaler);
   
   //glPushMatrix();
   //glPopMatrix();
   carup[0] = temp[0];
   carup[1] = temp[1];
   carup[2] = temp[2];
   //glPushMatrix();
   //glTranslatef(trans[0] / (scale * scaler), 
   //             findHeights(trans[0], trans[2] )/(scale*scaler), 
   //             trans[2] / (scale * scaler));
   //printf(" %f < %f\n", findHeights(trans[0], trans[2])/(scale*scaler), trans[1]/(scale*scaler));
   //glTranslatef(0.0f, 8.353187f/(scale*scaler), 0.0f);
   //animateProj();
    
   
   glTranslatef(trans[0] / (scale * scaler), 
                trans[1] / (scale * scaler), 
                trans[2] / (scale * scaler));
      
   
   if(sillyCar) {
      deformbox();
      ffdfunc();
   }
   crossProduct(0.0f, 1.0f, 0.0f, -temp[0], -temp[1], -temp[2]);
      
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   float adj = sqrt(pow(temp[2], 2)+pow(temp[0], 2));
   thetsAngle = atan2(adj, temp[1]);
   thetsAngle *= 57.2957795f;
   //printf("angle %f -> %f, %f, %f\n", thetsAngle, crossx, crossy, crossz);
   if(hModifier > .9 && !sillyCar)
      glRotatef(-thetsAngle - 180.0f, crossx, crossy, crossz);
   if(!sillyCar)
      glTranslatef(0.0f, 8.353187f/(scale*scaler), 0.0f);   
   if(rVector) {
      glBegin(GL_LINES);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3[night]);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(-temp[0]*10.0f, -temp[1]*10.0f, -temp[2]*10.0f);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3[night]);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(crossx*10.0f, crossy*10.0f, crossz*10.0f);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3[night]);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(10.0f, 0.0f, 0.0f);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, grey3[night]);
      glVertex3f(0.0f, 0.0f, 0.0f);
      glVertex3f(0.0f, 0.0f, 10.0f);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
      glEnd();
   }
   //glRotatef(rotateX, 1.0, 0.0, 0.0);
   if(!sillyCar)
      glRotatef(rotateY, 0.0, 1.0, 0.0);
   //glRotatef(rotateZ, 0.0, 0.0, 1.0);
   
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   if(drawChassis && !sillyCar)
      drawCar(coorn, coora, polya, night, polyLength, hlight, pressS, noglass, box, sillyCar);
   else if (sillyCar)
      drawWholeCar(ffdn, ffd, polya, night, polyLength, hlight, pressS, noglass, box, sillyCar);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3[night]);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -5.0);
      glVertex3f(0.0, 0.0, 5.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3[night]);
      glVertex3f(5.0, 0.0, 0.0);
      glVertex3f(-5.0, 0.0, 0.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3[night]);
      glVertex3f(0.0, 5.0, 0.0);
      glVertex3f(0.0, -5.0, 0.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   }

   //2.290254
   glPushMatrix();
   glTranslatef(-3.243832,  -0.499045, 1.303851);
   //glRotatef(90.0 - 19.2562621, 0.0, 0.0, 1.0);
   glRotatef(turn * 1000.0, 2.290254, 0.800073, 0.0);
   //glRotatef(-90.0 + 19.2562621, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3[night]);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -5.0);
      glVertex3f(0.0, 0.0, 5.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, red3[night]);
      glVertex3f(5.0, 0.0, 0.0);
      glVertex3f(-5.0, 0.0, 0.0);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, one3[night]);
      glVertex3f(0.0, 5.0, 0.0);
      glVertex3f(0.0, -5.0, 0.0); 
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   }
   if(!sillyCar)
      drawSteer(coorn, coora, polya, night, polyLength, box, sillyCar);
   glPopMatrix();

   glPushMatrix();
   glTranslatef(-4.498000, -1.739000, -2.524804);
   glRotatef(turn * 250.0, 0.0, 1.0, 0.0);
   glRotatef(wheelSpin, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3[night]);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -3.0);
      glVertex3f(0.0, 0.0, 3.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   }
   if(!sillyCar)
      drawRightTire(coorn, coora, polya, night, polyLength, box, sillyCar);
   
   glPopMatrix();
   
   glPushMatrix();
   glTranslatef(-4.498000, -1.739000, 2.524804);
   glRotatef(turn * 250.0, 0.0, 1.0, 0.0);
   glRotatef(wheelSpin, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3[night]);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -3.0);
      glVertex3f(0.0, 0.0, 3.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   }
   if(!sillyCar)
      drawLeftTire(coorn, coora, polya, night, polyLength, box, sillyCar);
   glPopMatrix();
   
   glPushMatrix();
   glTranslatef(5.048674, -1.739000, 0.0);
   glRotatef(wheelSpin, 0.0, 0.0, 1.0);
   if(partAxis){
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, zero3[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, blue3[night]);
      glBegin(GL_LINES);
      glVertex3f(0.0, 0.0, -5.0);
      glVertex3f(0.0, 0.0, 5.0);
      glEnd();
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   }
   if(!sillyCar)
      drawRearTires(coorn, coora, polya, night, polyLength, box, sillyCar);
   glPopMatrix();

   glPopMatrix();
   glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, zero3[night]);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, zero3[night]);
   drawWater();
   glPushMatrix();
   glScalef(scale * scaler, scale * scaler, scale * scaler);
   animateProj();
   glPopMatrix();
   /*
   
      
      gluLookAt(trans[0] + cameraDistance*look[0]*cos(cameraDegree) +
                           cameraDistance*crossx*sin(cameraDegree), 
                8.353187 + trans[1] + cameraUp, 
                trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                           cameraDistance*crossz*sin(cameraDegree),

   */
   crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
   float eyex = trans[0] + cameraDistance*look[0]*cos(cameraDegree) +
                           cameraDistance*crossx*sin(cameraDegree);
   float eyez = trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                           cameraDistance*crossz*sin(cameraDegree);
   if(8.353187 + trans[1] + cameraUp < waterLevel &&
      
      eyex < 1200 && eyex > -1200 &&
      eyez < 1200 && eyez > -1200) {
      glPushMatrix();
      //glEnable(GL_BLEND);
      //glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      crossProduct(look[0], look[1], look[2], up[0], up[1], up[2]);
      //glTranslatef(0.0, 100.0, 0.0);
      glTranslatef(trans[0] + cameraDistance*look[0]*cos(cameraDegree) +
                              cameraDistance*crossx*sin(cameraDegree), 
                   8.353187 + trans[1] + cameraUp, 
                   trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                              cameraDistance*crossz*sin(cameraDegree));
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, transp2[night]);
      //glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, clear[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, transp2[night]);
      glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, transp2[night]);

      glutSolidSphere(2.8, 8, 8);
      glPopMatrix();
   }
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, zero3[night]);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, zero3[night]);

   glPopMatrix();
   glutSwapBuffers();
}

// initalizes values before glut starts
void init(void) {
  carup[0] = 0.0f;
  carup[1] = 1.0f;
  carup[2] = 0.0f;
  for(int i = 0; i < PROJN; i++) {
     projectile[i][3] = 0;
  }
   //srand((unsigned)(time(0))); 

  //SKYBOX
    //loads skybox textures
  Image* front = loadBMP("../data/front.bmp");
  _skybox[0] = loadTexture(front);
  delete front;
  Image* left = loadBMP("../data/left.bmp");
  _skybox[1] = loadTexture(left);
  delete left;
  Image* back = loadBMP("../data/back.bmp");
  _skybox[2] = loadTexture(back);
  delete back;
  Image* right = loadBMP("../data/right.bmp");
  _skybox[3] = loadTexture(right);
  delete right;
  Image* top = loadBMP("../data/up.bmp");
  _skybox[4] = loadTexture(top);
  delete top;
  Image* bottom = loadBMP("../data/down.bmp");
  _skybox[5] = loadTexture(bottom);
  delete bottom;
  
   
  //END SKYBOX
  //this business loads the ground texture.
  Image* grass = loadBMP("../data/ground2.bmp");
  _skybox[6] = loadTexture(grass);
  delete grass;
  
  Image* water = loadBMP("../data/water2.bmp");
  _skybox[7] = loadTexture(water);
  delete water;
  

  //printFiles();
  glClearColor(0.0, 0.0, 0.8, 0.0);
  polyVectors();
  landVectors();
  glShadeModel(GL_SMOOTH);
  glPolygonMode(GL_FRONT, GL_FILL);
  glEnable(GL_DEPTH_TEST);
  //glEnable(GL_COLOR_MATERIAL);
  glMatrixMode(GL_PROJECTION);
  gluPerspective(  90.0, 1.0, 1.0, 8001.0);
  glMatrixMode(GL_MODELVIEW);
  trans[0] = trans[2] = 0.0;
  trans[1] = findHeights(trans[0], trans[2]);
  //ps[0][0] = ps[0][1] = ps[0][2] = ps[1][0] = ps[1][1] = ps[1][2] = 0.0;
  for(int i = 0; i < WATERD; i++) {
     for(int j = 0; j < WATERD; j++) {
       waterSurface[currw][i][j] = waterLevel;
       waterSurface[lastw][i][j] = waterLevel;
       waterSurface[oldw][i][j] = waterLevel;
     }
  }
}



// handles keyboard input
void keyboard(unsigned char key, int x, int y) {
   switch (key) {
      case 'u':
         fireProj(trans[0]/(scale*scaler), trans[1]/(scale*scaler), trans[2]/(scale*scaler), 
                  forward[0], 0.6f, forward[1], 1.0f);
         fireProj(trans[0]/(scale*scaler), trans[1]/(scale*scaler), trans[2]/(scale*scaler), 
                  forward[0], 0.6f, forward[1], 1.0f);
         fireProj(trans[0]/(scale*scaler), trans[1]/(scale*scaler), trans[2]/(scale*scaler), 
                  forward[0], 0.6f, forward[1], 1.0f);
         break;
      case 'r':
		   reset();
         break;
      case 'w':
         pressW = 1;
         break; 
      case 'a':
         pressA = 1;
         break;
      case 's':
         pressS = 1;
         break;
      case 'd':
         pressD = 1;
         break;
      case 'x':
         pressX = 1;
         break;
      case 'c':
         drawChassis = 1 - drawChassis;
         break;
      case 'v':
         driverview = 1 - driverview;
         break;
         
      case '.':
         sillyCar = 1 - sillyCar;
         if(sillyCar)
            sleeptime = SHORTSLEEP;
         else
            sleeptime = LONGSLEEP;
         break;
      //case 'g':
      //   noglass = 1 - noglass;
      //   break;
      case 'i':
         partAxis = 1 - partAxis;
         break;
      case 'n':
         drawNormal = 1 - drawNormal;
         break;
      case 't':
         //tAxis = 1 - tAxis;
         hlight = 1 - hlight;
         break;
      case 'k':
         rVector = 1 - rVector;
         break;
      case 'g':
         night = 1 - night;
         break;
      case 'o':
         if(waterRender[(int)trans[0]/(2400/WATERD) + WATERD/2][(int)trans[2]/(2400/WATERD) + WATERD/2] == 1) {
            waterSurface[currw][(int)trans[0]/(2400/WATERD) + WATERD/2][(int)trans[2]/(2400/WATERD) + WATERD/2] -= 80;
         }
         break;
      case 'y':
         waterLevel++;
         calcWater();
         setLandColor();
         break;
      case 'h':
         waterLevel--;
         calcWater();
         setLandColor();
         break;
      case '1':
         hModifier = 1.0f;
         calcWater();
         setLandColor();
         break;
      case '2':
         hModifier = 2.0f;
         calcWater();
         setLandColor();
         break;
      case '3':
         hModifier = 3.0f;
         calcWater();
         setLandColor();
         break;
      case '4':
         hModifier = 4.0f;
         calcWater();
         setLandColor();
         break;
      case '5':
         hModifier = 5.0f;
         calcWater();
         setLandColor();
         break;
      case '6':
         hModifier = 6.0f;
         calcWater();
         setLandColor();
         break;
      case '7':
         hModifier = 7.0f;
         calcWater();
         setLandColor();
         break;
      case '8':
         hModifier = 8.0f;
         calcWater();
         setLandColor();
         break;
      case '9':
         hModifier = 9.0f;
         calcWater();
         setLandColor();
         break;
      case '0':
         hModifier = 0.0f;
         calcWater();
         setLandColor();
         break;
   }
}

// disables flags when keys are no longer pressed
void keyup(unsigned char key, int x, int y) {
   switch(key) {
      case 'p':
         printf("pressM %d, pressH %d, pressV %d\nclickM %d clickH %d clickV %d\n", pressM, pressH, pressV, clickM, clickH, clickV);
         break;
      case 'w':
         pressW = 0;
         break; 
      case 'a':
         pressA = 0;
         break;
      case 's':
         pressS = 0;
         break;
      case 'd':
         pressD = 0;
         break;
      case 'x':
         pressX = 0;
         break;  
      case 'm':
         pressM = 0;
         break;
      case 'v':
         pressV = 0;
         break;
      case 'h':
         pressH = 0;
         break;
   }
}

//handles mouse clicks
void mouseClick(int button, int state, int x, int y){
   if (state == GLUT_DOWN){
      xMouse = x;
      yMouse = -y;
      if (button == GLUT_RIGHT_BUTTON) {
         rightC = 1;
      } else if (button == GLUT_MIDDLE_BUTTON) {
         middleC = 1;
      } else if (button == GLUT_LEFT_BUTTON) {
         leftC = 1;
      }
   } else {
      if (button == GLUT_RIGHT_BUTTON) {
         rightC = 0;
      } else if (button == GLUT_MIDDLE_BUTTON) {
         middleC = 0;
      } else if (button == GLUT_LEFT_BUTTON) {
         leftC = 0;
      }
   }
}



// tracks active mouse motion
void motion(int x, int y){
   if (rightC) {
      float underC;
	   underC = findHeights(trans[0] + 
                  cameraDistance*look[0]*cos(cameraDegree) +
                  cameraDistance*crossx*sin(cameraDegree), 
                  trans[2] + cameraDistance*look[2]*cos(cameraDegree) +  
                  cameraDistance*crossz*sin(cameraDegree));
      //printf("underc %f\n", underC);
      if(underC <  trans[1] + cameraUp + (yMouse + y)/2.0) 
        cameraUp += (yMouse + y)/2.0;
      yMouse = -y;
   } else if (leftC) {
      cameraDegree += (xMouse - x)/50.0;
      xMouse = x;
   } else if (middleC) {
      cameraDistance += (yMouse + y)/2.0;
      if(cameraDistance >= 0.0)
         cameraDistance = -1.0;
      yMouse = -y;
   }
}

void reshape (int w, int h) {
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   width = w;
   hight = h;
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   gluPerspective(  110.0, (float)width/(float)hight, 1.0, 1001.0);
   glMatrixMode (GL_MODELVIEW);
}

int main(int argc, char **argv) {
   // reads in the input files in a crazy c++ style
   int coorN = 0, pollyN = 0;

   ifstream coorIn ("../data/chevy.coor" );
   coorIn >> coorLength;
   coorLength++;
   for(int i = 1; i <=coorLength; i++) {
      int n;
      char c;
      coorIn>>n>>c>>coora[i][0]>>c>>coora[i][1]>>c>>coora[i][2]; 
      if(coora[i][0] > xmax)
         xmax = coora[i][0];
      if(coora[i][0] < xmin)
         xmin = coora[i][0];
      if(coora[i][1] > ymax)
         ymax = coora[i][1];
      if(coora[i][1] < ymin)
         ymin = coora[i][1];
      if(coora[i][2] > zmax)
         zmax = coora[i][2];
      if(coora[i][2] < zmin)
         zmin = coora[i][2];      
   }
   xdif = xmax - xmin;
   ydif = ymax - ymin;
   zdif = zmax - zmin;
   big = xdif;
   if(ydif > big)
      big = ydif;
   if(zdif > big)
      big = zdif;
   //scale = 1.0;
   scale = 100.0/big;
   ifstream polyIn ("../data/chevy.poly" );
   polyIn >> polyLength;
   for(int i = 0; i <=polyLength; i++) {
      char line[1024];
      string name;
      int j = 1;
      
      polyIn.getline( line, 512);
      stringstream ss(stringstream:: in | stringstream:: out);
      ss << line;
      ss >> name;
      while(ss.good() ) {
         ss >> polya[i][j++];
      }
      polya[i][0] = j - 2;
             
   }
   
  
   ground = loadTerrain("../data/heightmap.bmp", 20); 
   calcWater();
   setLandColor();
   
   // starts and runs glut
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
   glutInitWindowSize (1000, 800); 
   glutInitWindowPosition (10, 10);
   glutCreateWindow(argv[0]);
   glutDisplayFunc(display);
   glutKeyboardFunc(keyboard);
   glutKeyboardUpFunc(keyup);
   glutMouseFunc(mouseClick);
   glutReshapeFunc(reshape);
   glutMotionFunc(motion);
   glutIdleFunc(idle);
   init();
   glutMainLoop();
   return 0;
}

